// Code generated by goctl. DO NOT EDIT.
package types

type ActiveReward struct {
	TotalReward float64          `json:"total_reward"`
	Today       ActiveRewardData `json:"today"`   // 今日数据
	Last7D      ActiveRewardData `json:"last7d"`  // 近7天数据
	Last30D     ActiveRewardData `json:"last30d"` // 近30天数据
}

type ActiveRewardData struct {
	NewActiveReward   float64 `json:"active_reward"`
	SubPromoteReward  float64 `json:"sub_promote_reward"`
	SubUpgradeReward  float64 `json:"sub_upgrade_reward"`
	SubWithdrawReward float64 `json:"sub_withdraw_reward"`
}

type AdminCreateFeatureReq struct {
	ApiId string `json:"api_id"` // API标识
	Name  string `json:"name"`   // 描述
}

type AdminCreateFeatureResp struct {
	Id int64 `json:"id"` // 功能ID
}

type AdminCreateNotificationReq struct {
	Title            string `json:"title"`             // 通知标题
	NotificationPage string `json:"notification_page"` // 通知页面
	Content          string `json:"content"`           // 通知内容
	StartDate        string `json:"start_date"`        // 生效开始日期（yyyy-MM-dd）
	StartTime        string `json:"start_time"`        // 生效开始时间（HH:mm:ss）
	EndDate          string `json:"end_date"`          // 生效结束日期（yyyy-MM-dd）
	EndTime          string `json:"end_time"`          // 生效结束时间（HH:mm:ss）
	Status           int64  `json:"status"`            // 状态：1-启用，0-禁用
}

type AdminCreateNotificationResp struct {
	Id int64 `json:"id"` // 通知ID
}

type AdminCreateOrderReq struct {
	OrderNo         string  `json:"order_no"`               // 商户订单号
	PlatformOrderId string  `json:"platform_order_id"`      // 支付订单号
	ProductName     string  `json:"product_name"`           // 产品名称
	PaymentPlatform string  `json:"payment_platform"`       // 支付方式
	PaymentScene    string  `json:"payment_scene"`          // 支付平台
	Amount          float64 `json:"amount"`                 // 金额
	Status          string  `json:"status,default=pending"` // 支付状态：pending-待支付，paid-已支付，refunded-已退款，closed-已关闭，failed-支付失败
	IsPromotion     int64   `json:"is_promotion,default=0"` // 是否推广订单：0-否，1-是
}

type AdminCreateOrderResp struct {
	Id int64 `json:"id"` // 订单ID
}

type AdminCreatePlatformUserReq struct {
	Mobile   string `json:"mobile"`   // 手机号
	Password string `json:"password"` // 密码
	Nickname string `json:"nickname"` // 昵称
	Info     string `json:"info"`     // 备注信息
	Inside   int64  `json:"inside"`   // 是否内部用户 1-是 0-否
}

type AdminCreatePlatformUserResp struct {
	Id int64 `json:"id"` // 用户ID
}

type AdminCreateProductReq struct {
	ProductName string  `json:"product_name"`   // 服务名
	ProductEn   string  `json:"product_en"`     // 英文名
	Description string  `json:"description"`    // 描述
	Notes       string  `json:"notes,optional"` // 备注
	CostPrice   float64 `json:"cost_price"`     // 成本
	SellPrice   float64 `json:"sell_price"`     // 售价
}

type AdminCreateProductResp struct {
	Id int64 `json:"id"` // 产品ID
}

type AdminCreateUserReq struct {
	Username string  `json:"username"`         // 用户名
	RealName string  `json:"real_name"`        // 真实姓名
	Status   int64   `json:"status,default=1"` // 状态：0-禁用，1-启用
	RoleIds  []int64 `json:"role_ids"`         // 关联的角色ID列表
}

type AdminCreateUserResp struct {
	Id int64 `json:"id"` // 用户ID
}

type AdminDeleteFeatureReq struct {
	Id int64 `path:"id"` // 功能ID
}

type AdminDeleteFeatureResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminDeleteNotificationReq struct {
	Id int64 `path:"id"` // 通知ID
}

type AdminDeleteNotificationResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminDeleteOrderReq struct {
	Id int64 `path:"id"` // 订单ID
}

type AdminDeleteOrderResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminDeletePlatformUserReq struct {
	Id int64 `path:"id"` // 用户ID
}

type AdminDeletePlatformUserResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminDeleteProductReq struct {
	Id int64 `path:"id"` // 产品ID
}

type AdminDeleteProductResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminDeleteUserReq struct {
	Id int64 `path:"id"` // 用户ID
}

type AdminDeleteUserResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminGetAgentCommissionDeductionListReq struct {
	Page        int64   `form:"page"`                  // 页码
	PageSize    int64   `form:"pageSize"`              // 每页数量
	AgentId     *int64  `form:"agent_id,optional"`     // 代理ID（可选）
	ProductName *string `form:"product_name,optional"` // 产品名（可选）
	Type        *string `form:"type,optional"`         // 类型（cost/pricing，可选）
	Status      *int64  `form:"status,optional"`       // 状态（可选）
}

type AdminGetAgentCommissionDeductionListResp struct {
	Total int64                              `json:"total"` // 总数
	Items []AgentCommissionDeductionListItem `json:"items"` // 列表数据
}

type AdminGetAgentCommissionListReq struct {
	Page        int64   `form:"page"`                  // 页码
	PageSize    int64   `form:"pageSize"`              // 每页数量
	AgentId     *int64  `form:"agent_id,optional"`     // 代理ID（可选）
	ProductName *string `form:"product_name,optional"` // 产品名（可选）
	Status      *int64  `form:"status,optional"`       // 状态（可选）
}

type AdminGetAgentCommissionListResp struct {
	Total int64                     `json:"total"` // 总数
	Items []AgentCommissionListItem `json:"items"` // 列表数据
}

type AdminGetAgentLinkListReq struct {
	Page           int64   `form:"page"`                     // 页码
	PageSize       int64   `form:"pageSize"`                 // 每页数量
	AgentId        *int64  `form:"agent_id,optional"`        // 代理ID（可选）
	ProductName    *string `form:"product_name,optional"`    // 产品名（可选）
	LinkIdentifier *string `form:"link_identifier,optional"` // 推广码（可选）
}

type AdminGetAgentLinkListResp struct {
	Total int64               `json:"total"` // 总数
	Items []AgentLinkListItem `json:"items"` // 列表数据
}

type AdminGetAgentListReq struct {
	Page          int64   `form:"page"`                     // 页码
	PageSize      int64   `form:"pageSize"`                 // 每页数量
	Mobile        *string `form:"mobile,optional"`          // 手机号（可选）
	Region        *string `form:"region,optional"`          // 区域（可选）
	ParentAgentId *int64  `form:"parent_agent_id,optional"` // 上级代理ID（可选）
}

type AdminGetAgentListResp struct {
	Total int64           `json:"total"` // 总数
	Items []AgentListItem `json:"items"` // 列表数据
}

type AdminGetAgentMembershipConfigListReq struct {
	Page      int64   `form:"page"`                // 页码
	PageSize  int64   `form:"pageSize"`            // 每页数量
	LevelName *string `form:"level_name,optional"` // 会员级别名称（可选）
}

type AdminGetAgentMembershipConfigListResp struct {
	Total int64                           `json:"total"` // 总数
	Items []AgentMembershipConfigListItem `json:"items"` // 列表数据
}

type AdminGetAgentMembershipRechargeOrderListReq struct {
	Page            int64   `form:"page"`                       // 页码
	PageSize        int64   `form:"pageSize"`                   // 每页数量
	UserId          *int64  `form:"user_id,optional"`           // 用户ID（可选）
	AgentId         *int64  `form:"agent_id,optional"`          // 代理ID（可选）
	OrderNo         *string `form:"order_no,optional"`          // 订单号（可选）
	PlatformOrderId *string `form:"platform_order_id,optional"` // 平台订单号（可选）
	Status          *string `form:"status,optional"`            // 状态（可选）
	PaymentMethod   *string `form:"payment_method,optional"`    // 支付方式（可选）
}

type AdminGetAgentMembershipRechargeOrderListResp struct {
	Total int64                                  `json:"total"` // 总数
	Items []AgentMembershipRechargeOrderListItem `json:"items"` // 列表数据
}

type AdminGetAgentPlatformDeductionListReq struct {
	Page     int64   `form:"page"`              // 页码
	PageSize int64   `form:"pageSize"`          // 每页数量
	AgentId  *int64  `form:"agent_id,optional"` // 代理ID（可选）
	Type     *string `form:"type,optional"`     // 类型（cost/pricing，可选）
	Status   *int64  `form:"status,optional"`   // 状态（可选）
}

type AdminGetAgentPlatformDeductionListResp struct {
	Total int64                            `json:"total"` // 总数
	Items []AgentPlatformDeductionListItem `json:"items"` // 列表数据
}

type AdminGetAgentProductionConfigListReq struct {
	Page        int64   `form:"page"`                  // 页码
	PageSize    int64   `form:"pageSize"`              // 每页数量
	ProductName *string `form:"product_name,optional"` // 产品名（可选）
	Id          *int64  `form:"id,optional"`           // 配置ID（可选）
}

type AdminGetAgentProductionConfigListResp struct {
	Total int64                       `json:"total"` // 总数
	Items []AgentProductionConfigItem `json:"items"` // 列表数据
}

type AdminGetAgentRewardListReq struct {
	Page            int64   `form:"page"`                       // 页码
	PageSize        int64   `form:"pageSize"`                   // 每页数量
	AgentId         *int64  `form:"agent_id,optional"`          // 代理ID（可选）
	RelationAgentId *int64  `form:"relation_agent_id,optional"` // 关联代理ID（可选）
	Type            *string `form:"type,optional"`              // 奖励类型（可选）
}

type AdminGetAgentRewardListResp struct {
	Total int64                 `json:"total"` // 总数
	Items []AgentRewardListItem `json:"items"` // 列表数据
}

type AdminGetAgentWithdrawalListReq struct {
	Page       int64   `form:"page"`                 // 页码
	PageSize   int64   `form:"pageSize"`             // 每页数量
	AgentId    *int64  `form:"agent_id,optional"`    // 代理ID（可选）
	Status     *int64  `form:"status,optional"`      // 状态（可选）
	WithdrawNo *string `form:"withdraw_no,optional"` // 提现单号（可选）
}

type AdminGetAgentWithdrawalListResp struct {
	Total int64                     `json:"total"` // 总数
	Items []AgentWithdrawalListItem `json:"items"` // 列表数据
}

type AdminGetFeatureDetailReq struct {
	Id int64 `path:"id"` // 功能ID
}

type AdminGetFeatureDetailResp struct {
	Id         int64  `json:"id"`          // 功能ID
	ApiId      string `json:"api_id"`      // API标识
	Name       string `json:"name"`        // 描述
	CreateTime string `json:"create_time"` // 创建时间
	UpdateTime string `json:"update_time"` // 更新时间
}

type AdminGetFeatureListReq struct {
	Page     int64   `form:"page"`            // 页码
	PageSize int64   `form:"pageSize"`        // 每页数量
	ApiId    *string `form:"api_id,optional"` // API标识
	Name     *string `form:"name,optional"`   // 描述
}

type AdminGetFeatureListResp struct {
	Total int64             `json:"total"` // 总数
	Items []FeatureListItem `json:"items"` // 列表数据
}

type AdminGetNotificationDetailReq struct {
	Id int64 `path:"id"` // 通知ID
}

type AdminGetNotificationDetailResp struct {
	Id               int64  `json:"id"`                // 通知ID
	Title            string `json:"title"`             // 通知标题
	Content          string `json:"content"`           // 通知内容
	NotificationPage string `json:"notification_page"` // 通知页面
	StartDate        string `json:"start_date"`        // 生效开始日期
	StartTime        string `json:"start_time"`        // 生效开始时间
	EndDate          string `json:"end_date"`          // 生效结束日期
	EndTime          string `json:"end_time"`          // 生效结束时间
	Status           int64  `json:"status"`            // 状态
	CreateTime       string `json:"create_time"`       // 创建时间
	UpdateTime       string `json:"update_time"`       // 更新时间
}

type AdminGetNotificationListReq struct {
	Page             int64   `form:"page"`                       // 页码
	PageSize         int64   `form:"pageSize"`                   // 每页数量
	Title            *string `form:"title,optional"`             // 通知标题（可选）
	NotificationPage *string `form:"notification_page,optional"` // 通知页面（可选）
	Status           *int64  `form:"status,optional"`            // 状态（可选）
	StartDate        *string `form:"start_date,optional"`        // 开始日期范围（可选）
	EndDate          *string `form:"end_date,optional"`          // 结束日期范围（可选）
}

type AdminGetNotificationListResp struct {
	Total int64                  `json:"total"` // 总数
	Items []NotificationListItem `json:"items"` // 列表数据
}

type AdminGetOrderDetailReq struct {
	Id int64 `path:"id"` // 订单ID
}

type AdminGetOrderDetailResp struct {
	Id              int64   `json:"id"`                // 订单ID
	OrderNo         string  `json:"order_no"`          // 商户订单号
	PlatformOrderId string  `json:"platform_order_id"` // 支付订单号
	ProductName     string  `json:"product_name"`      // 产品名称
	PaymentPlatform string  `json:"payment_platform"`  // 支付方式
	PaymentScene    string  `json:"payment_scene"`     // 支付平台
	Amount          float64 `json:"amount"`            // 金额
	Status          string  `json:"status"`            // 支付状态：pending-待支付，paid-已支付，refunded-已退款，closed-已关闭，failed-支付失败
	QueryState      string  `json:"query_state"`       // 查询状态：pending-待查询，success-查询成功，failed-查询失败 processing-查询中
	CreateTime      string  `json:"create_time"`       // 创建时间
	PayTime         string  `json:"pay_time"`          // 支付时间
	RefundTime      string  `json:"refund_time"`       // 退款时间
	IsPromotion     int64   `json:"is_promotion"`      // 是否推广订单：0-否，1-是
	UpdateTime      string  `json:"update_time"`       // 更新时间
}

type AdminGetOrderListReq struct {
	Page            int64   `form:"page,default=1"`                   // 页码
	PageSize        int64   `form:"pageSize,default=20"`              // 每页数量
	OrderNo         string  `form:"order_no,optional"`                // 商户订单号
	PlatformOrderId string  `form:"platform_order_id,optional"`       // 支付订单号
	ProductName     string  `form:"product_name,optional"`            // 产品名称
	PaymentPlatform string  `form:"payment_platform,optional"`        // 支付方式
	PaymentScene    string  `form:"payment_scene,optional"`           // 支付平台
	Amount          float64 `form:"amount,optional"`                  // 金额
	Status          string  `form:"status,optional"`                  // 支付状态：pending-待支付，paid-已支付，refunded-已退款，closed-已关闭，failed-支付失败
	IsPromotion     int64   `form:"is_promotion,optional,default=-1"` // 是否推广订单：0-否，1-是
	CreateTimeStart string  `form:"create_time_start,optional"`       // 创建时间开始
	CreateTimeEnd   string  `form:"create_time_end,optional"`         // 创建时间结束
	PayTimeStart    string  `form:"pay_time_start,optional"`          // 支付时间开始
	PayTimeEnd      string  `form:"pay_time_end,optional"`            // 支付时间结束
	RefundTimeStart string  `form:"refund_time_start,optional"`       // 退款时间开始
	RefundTimeEnd   string  `form:"refund_time_end,optional"`         // 退款时间结束
}

type AdminGetOrderListResp struct {
	Total int64           `json:"total"` // 总数
	Items []OrderListItem `json:"items"` // 列表
}

type AdminGetPlatformUserDetailReq struct {
	Id int64 `path:"id"` // 用户ID
}

type AdminGetPlatformUserDetailResp struct {
	Id         int64  `json:"id"`          // 用户ID
	Mobile     string `json:"mobile"`      // 手机号
	Nickname   string `json:"nickname"`    // 昵称
	Info       string `json:"info"`        // 备注信息
	Inside     int64  `json:"inside"`      // 是否内部用户 1-是 0-否
	CreateTime string `json:"create_time"` // 创建时间
	UpdateTime string `json:"update_time"` // 更新时间
}

type AdminGetPlatformUserListReq struct {
	Page            int64  `form:"page,default=1"`             // 页码
	PageSize        int64  `form:"pageSize,default=20"`        // 每页数量
	Mobile          string `form:"mobile,optional"`            // 手机号
	Nickname        string `form:"nickname,optional"`          // 昵称
	Inside          int64  `form:"inside,optional"`            // 是否内部用户 1-是 0-否
	CreateTimeStart string `form:"create_time_start,optional"` // 创建时间开始
	CreateTimeEnd   string `form:"create_time_end,optional"`   // 创建时间结束
	OrderBy         string `form:"order_by,optional"`          // 排序字段
	OrderType       string `form:"order_type,optional"`        // 排序类型
}

type AdminGetPlatformUserListResp struct {
	Total int64                  `json:"total"` // 总数
	Items []PlatformUserListItem `json:"items"` // 列表
}

type AdminGetProductDetailReq struct {
	Id int64 `path:"id"` // 产品ID
}

type AdminGetProductDetailResp struct {
	Id          int64   `json:"id"`           // 产品ID
	ProductName string  `json:"product_name"` // 服务名
	ProductEn   string  `json:"product_en"`   // 英文名
	Description string  `json:"description"`  // 描述
	Notes       string  `json:"notes"`        // 备注
	CostPrice   float64 `json:"cost_price"`   // 成本
	SellPrice   float64 `json:"sell_price"`   // 售价
	CreateTime  string  `json:"create_time"`  // 创建时间
	UpdateTime  string  `json:"update_time"`  // 更新时间
}

type AdminGetProductFeatureListReq struct {
	ProductId int64 `path:"product_id"` // 产品ID
}

type AdminGetProductFeatureListResp struct {
	Id          int64  `json:"id"`           // 关联ID
	ProductId   int64  `json:"product_id"`   // 产品ID
	FeatureId   int64  `json:"feature_id"`   // 功能ID
	ApiId       string `json:"api_id"`       // API标识
	Name        string `json:"name"`         // 功能描述
	Sort        int64  `json:"sort"`         // 排序
	Enable      int64  `json:"enable"`       // 是否启用
	IsImportant int64  `json:"is_important"` // 是否重要
	CreateTime  string `json:"create_time"`  // 创建时间
	UpdateTime  string `json:"update_time"`  // 更新时间
}

type AdminGetProductListReq struct {
	Page        int64   `form:"page"`                  // 页码
	PageSize    int64   `form:"pageSize"`              // 每页数量
	ProductName *string `form:"product_name,optional"` // 服务名
	ProductEn   *string `form:"product_en,optional"`   // 英文名
}

type AdminGetProductListResp struct {
	Total int64             `json:"total"` // 总数
	Items []ProductListItem `json:"items"` // 列表数据
}

type AdminGetQueryCleanupConfigListReq struct {
	Status int64 `form:"status,optional"` // 状态：1-启用，0-禁用
}

type AdminGetQueryCleanupConfigListResp struct {
	Items []QueryCleanupConfigItem `json:"items"` // 配置列表
}

type AdminGetQueryCleanupDetailListReq struct {
	LogId    int64 `path:"log_id"`               // 清理日志ID
	Page     int64 `form:"page,default=1"`       // 页码
	PageSize int64 `form:"page_size,default=20"` // 每页数量
}

type AdminGetQueryCleanupDetailListResp struct {
	Total int64                    `json:"total"` // 总数
	Items []QueryCleanupDetailItem `json:"items"` // 列表
}

type AdminGetQueryCleanupLogListReq struct {
	Page      int64  `form:"page,default=1"`       // 页码
	PageSize  int64  `form:"page_size,default=20"` // 每页数量
	Status    int64  `form:"status,optional"`      // 状态：1-成功，2-失败
	StartTime string `form:"start_time,optional"`  // 开始时间
	EndTime   string `form:"end_time,optional"`    // 结束时间
}

type AdminGetQueryCleanupLogListResp struct {
	Total int64                 `json:"total"` // 总数
	Items []QueryCleanupLogItem `json:"items"` // 列表
}

type AdminGetQueryDetailByOrderIdReq struct {
	OrderId int64 `path:"order_id"`
}

type AdminGetQueryDetailByOrderIdResp struct {
	Id          int64                  `json:"id"`           // 主键ID
	OrderId     int64                  `json:"order_id"`     // 订单ID
	UserId      int64                  `json:"user_id"`      // 用户ID
	ProductName string                 `json:"product_name"` // 产品ID
	QueryParams map[string]interface{} `json:"query_params"`
	QueryData   []AdminQueryItem       `json:"query_data"`
	CreateTime  string                 `json:"create_time"` // 创建时间
	UpdateTime  string                 `json:"update_time"` // 更新时间
	QueryState  string                 `json:"query_state"` // 查询状态
}

type AdminGetUserDetailReq struct {
	Id int64 `path:"id"` // 用户ID
}

type AdminGetUserDetailResp struct {
	Id         int64   `json:"id"`          // 用户ID
	Username   string  `json:"username"`    // 用户名
	RealName   string  `json:"real_name"`   // 真实姓名
	Status     int64   `json:"status"`      // 状态：0-禁用，1-启用
	CreateTime string  `json:"create_time"` // 创建时间
	UpdateTime string  `json:"update_time"` // 更新时间
	RoleIds    []int64 `json:"role_ids"`    // 关联的角色ID列表
}

type AdminGetUserListReq struct {
	Page     int64  `form:"page,default=1"`             // 页码
	PageSize int64  `form:"pageSize,default=20"`        // 每页数量
	Username string `form:"username,optional"`          // 用户名
	RealName string `form:"real_name,optional"`         // 真实姓名
	Status   int64  `form:"status,optional,default=-1"` // 状态：0-禁用，1-启用
}

type AdminGetUserListResp struct {
	Total int64               `json:"total"` // 总数
	Items []AdminUserListItem `json:"items"` // 列表
}

type AdminLoginReq struct {
	Username string `json:"username" validate:"required"`
	Password string `json:"password" validate:"required"`
	Captcha  bool   `json:"captcha" validate:"required"`
}

type AdminLoginResp struct {
	AccessToken  string   `json:"access_token"`
	AccessExpire int64    `json:"access_expire"`
	RefreshAfter int64    `json:"refresh_after"`
	Roles        []string `json:"roles"`
}

type AdminQueryItem struct {
	Feature interface{} `json:"feature"`
	Data    interface{} `json:"data"` // 这里可以是 map 或 具体的 struct
}

type AdminRefundOrderReq struct {
	Id           int64   `path:"id"`            // 订单ID
	RefundAmount float64 `json:"refund_amount"` // 退款金额
	RefundReason string  `json:"refund_reason"` // 退款原因
}

type AdminRefundOrderResp struct {
	Status   string  `json:"status"`    // 退款状态
	RefundNo string  `json:"refund_no"` // 退款单号
	Amount   float64 `json:"amount"`    // 退款金额
}

type AdminUpdateAgentMembershipConfigReq struct {
	Id                       int64    `json:"id"`                                             // 主键
	LevelName                string   `json:"level_name"`                                     // 会员级别名称
	Price                    float64  `json:"price"`                                          // 会员年费
	ReportCommission         float64  `json:"report_commission"`                              // 直推报告收益
	LowerActivityReward      *float64 `json:"lower_activity_reward,optional,omitempty"`       // 下级活跃奖励金额
	NewActivityReward        *float64 `json:"new_activity_reward,optional,omitempty"`         // 新增活跃奖励金额
	LowerStandardCount       *int64   `json:"lower_standard_count,optional,omitempty"`        // 活跃下级达标个数
	NewLowerStandardCount    *int64   `json:"new_lower_standard_count,optional,omitempty"`    // 新增活跃下级达标个数
	LowerWithdrawRewardRatio *float64 `json:"lower_withdraw_reward_ratio,optional,omitempty"` // 下级提现奖励比例
	LowerConvertVipReward    *float64 `json:"lower_convert_vip_reward,optional,omitempty"`    // 下级转化VIP奖励
	LowerConvertSvipReward   *float64 `json:"lower_convert_svip_reward,optional,omitempty"`   // 下级转化SVIP奖励
	ExemptionAmount          *float64 `json:"exemption_amount,optional,omitempty"`            // 免责金额
	PriceIncreaseMax         *float64 `json:"price_increase_max,optional,omitempty"`          // 提价最高金额
	PriceRatio               *float64 `json:"price_ratio,optional,omitempty"`                 // 提价区间收取比例
	PriceIncreaseAmount      *float64 `json:"price_increase_amount,optional,omitempty"`       // 在原本成本上加价的金额
}

type AdminUpdateAgentMembershipConfigResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUpdateAgentProductionConfigReq struct {
	Id               int64   `json:"id"`                // 主键
	CostPrice        float64 `json:"cost_price"`        // 成本
	PriceRangeMin    float64 `json:"price_range_min"`   // 最低定价
	PriceRangeMax    float64 `json:"price_range_max"`   // 最高定价
	PricingStandard  float64 `json:"pricing_standard"`  // 定价标准
	OverpricingRatio float64 `json:"overpricing_ratio"` // 超价比例
}

type AdminUpdateAgentProductionConfigResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUpdateFeatureReq struct {
	Id    int64   `path:"id"`              // 功能ID
	ApiId *string `json:"api_id,optional"` // API标识
	Name  *string `json:"name,optional"`   // 描述
}

type AdminUpdateFeatureResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUpdateNotificationReq struct {
	Id               int64   `path:"id"`                         // 通知ID
	Title            *string `json:"title,optional"`             // 通知标题
	Content          *string `json:"content,optional"`           // 通知内容
	NotificationPage *string `json:"notification_page,optional"` // 通知页面
	StartDate        *string `json:"start_date,optional"`        // 生效开始日期
	StartTime        *string `json:"start_time,optional"`        // 生效开始时间
	EndDate          *string `json:"end_date,optional"`          // 生效结束日期
	EndTime          *string `json:"end_time,optional"`          // 生效结束时间
	Status           *int64  `json:"status,optional"`            // 状态
}

type AdminUpdateNotificationResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUpdateOrderReq struct {
	Id              int64    `path:"id"`                         // 订单ID
	OrderNo         *string  `json:"order_no,optional"`          // 商户订单号
	PlatformOrderId *string  `json:"platform_order_id,optional"` // 支付订单号
	ProductName     *string  `json:"product_name,optional"`      // 产品名称
	PaymentPlatform *string  `json:"payment_platform,optional"`  // 支付方式
	PaymentScene    *string  `json:"payment_scene,optional"`     // 支付平台
	Amount          *float64 `json:"amount,optional"`            // 金额
	Status          *string  `json:"status,optional"`            // 支付状态：pending-待支付，paid-已支付，refunded-已退款，closed-已关闭，failed-支付失败
	PayTime         *string  `json:"pay_time,optional"`          // 支付时间
	RefundTime      *string  `json:"refund_time,optional"`       // 退款时间
	IsPromotion     *int64   `json:"is_promotion,optional"`      // 是否推广订单：0-否，1-是
}

type AdminUpdateOrderResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUpdatePlatformUserReq struct {
	Id       int64   `path:"id"`                // 用户ID
	Mobile   *string `json:"mobile,optional"`   // 手机号
	Password *string `json:"password,optional"` // 密码
	Nickname *string `json:"nickname,optional"` // 昵称
	Info     *string `json:"info,optional"`     // 备注信息
	Inside   *int64  `json:"inside,optional"`   // 是否内部用户 1-是 0-否
}

type AdminUpdatePlatformUserResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUpdateProductFeaturesReq struct {
	ProductId int64                `path:"product_id"` // 产品ID
	Features  []ProductFeatureItem `json:"features"`   // 功能列表
}

type AdminUpdateProductFeaturesResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUpdateProductReq struct {
	Id          int64    `path:"id"`                    // 产品ID
	ProductName *string  `json:"product_name,optional"` // 服务名
	ProductEn   *string  `json:"product_en,optional"`   // 英文名
	Description *string  `json:"description,optional"`  // 描述
	Notes       *string  `json:"notes,optional"`        // 备注
	CostPrice   *float64 `json:"cost_price,optional"`   // 成本
	SellPrice   *float64 `json:"sell_price,optional"`   // 售价
}

type AdminUpdateProductResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUpdateQueryCleanupConfigReq struct {
	Id          int64  `json:"id"`           // 主键ID
	ConfigValue string `json:"config_value"` // 配置值
	Status      int64  `json:"status"`       // 状态：1-启用，0-禁用
}

type AdminUpdateQueryCleanupConfigResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUpdateUserReq struct {
	Id       int64   `path:"id"`                 // 用户ID
	Username *string `json:"username,optional"`  // 用户名
	RealName *string `json:"real_name,optional"` // 真实姓名
	Status   *int64  `json:"status,optional"`    // 状态：0-禁用，1-启用
	RoleIds  []int64 `json:"role_ids,optional"`  // 关联的角色ID列表
}

type AdminUpdateUserResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUserInfoReq struct {
}

type AdminUserInfoResp struct {
	Username string   `json:"username"`  // 用户名
	RealName string   `json:"real_name"` // 真实姓名
	Roles    []string `json:"roles"`     // 角色编码列表
}

type AdminUserListItem struct {
	Id         int64   `json:"id"`          // 用户ID
	Username   string  `json:"username"`    // 用户名
	RealName   string  `json:"real_name"`   // 真实姓名
	Status     int64   `json:"status"`      // 状态：0-禁用，1-启用
	CreateTime string  `json:"create_time"` // 创建时间
	RoleIds    []int64 `json:"role_ids"`    // 关联的角色ID列表
}

type AgentActivateMembershipReq struct {
	Type string `json:"type,oneof=VIP SVIP"` // 会员类型：vip/svip
}

type AgentActivateMembershipResp struct {
	Id string `json:"id"`
}

type AgentApplyReq struct {
	Region   string `json:"region"`
	Mobile   string `json:"mobile"`
	Code     string `json:"code"`
	Ancestor string `json:"ancestor,optional"`
}

type AgentApplyResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type AgentAuditStatusResp struct {
	Status      int64  `json:"status"` // 0=待审核，1=审核通过，2=审核未通过
	AuditReason string `json:"audit_reason"`
}

type AgentCommissionDeductionListItem struct {
	Id              int64   `json:"id"`                // 主键
	AgentId         int64   `json:"agent_id"`          // 代理ID
	DeductedAgentId int64   `json:"deducted_agent_id"` // 被扣代理ID
	Amount          float64 `json:"amount"`            // 金额
	ProductName     string  `json:"product_name"`      // 产品名
	Type            string  `json:"type"`              // 类型（cost/pricing）
	Status          int64   `json:"status"`            // 状态
	CreateTime      string  `json:"create_time"`       // 创建时间
}

type AgentCommissionListItem struct {
	Id          int64   `json:"id"`           // 主键
	AgentId     int64   `json:"agent_id"`     // 代理ID
	OrderId     int64   `json:"order_id"`     // 订单ID
	Amount      float64 `json:"amount"`       // 金额
	ProductName string  `json:"product_name"` // 产品名
	Status      int64   `json:"status"`       // 状态
	CreateTime  string  `json:"create_time"`  // 创建时间
}

type AgentGeneratingLinkReq struct {
	Product string `json:"product"`
	Price   string `json:"price"`
}

type AgentGeneratingLinkResp struct {
	LinkIdentifier string `json:"link_identifier"`
}

type AgentInfoResp struct {
	Status     int64  `json:"status"` // 0=待审核，1=审核通过，2=审核未通过，3=未申请
	IsAgent    bool   `json:"is_agent"`
	AgentID    int64  `json:"agent_id"`
	Level      string `json:"level"`
	Region     string `json:"region"`
	Mobile     string `json:"mobile"`
	ExpiryTime string `json:"expiry_time"`
	IsRealName bool   `json:"is_real_name"`
}

type AgentLinkListItem struct {
	AgentId        int64   `json:"agent_id"`        // 代理ID
	ProductName    string  `json:"product_name"`    // 产品名
	Price          float64 `json:"price"`           // 价格
	LinkIdentifier string  `json:"link_identifier"` // 推广码
	CreateTime     string  `json:"create_time"`     // 创建时间
}

type AgentListItem struct {
	Id                   int64   `json:"id"`                     // 主键
	UserId               int64   `json:"user_id"`                // 用户ID
	ParentAgentId        int64   `json:"parent_agent_id"`        // 上级代理ID
	LevelName            string  `json:"level_name"`             // 等级名称
	Region               string  `json:"region"`                 // 区域
	Mobile               string  `json:"mobile"`                 // 手机号
	MembershipExpiryTime string  `json:"membership_expiry_time"` // 会员到期时间
	Balance              float64 `json:"balance"`                // 钱包余额
	TotalEarnings        float64 `json:"total_earnings"`         // 累计收益
	FrozenBalance        float64 `json:"frozen_balance"`         // 冻结余额
	WithdrawnAmount      float64 `json:"withdrawn_amount"`       // 提现总额
	CreateTime           string  `json:"create_time"`            // 创建时间
	IsRealNameVerified   bool    `json:"is_real_name_verified"`  // 是否已实名认证
	RealName             string  `json:"real_name"`              // 实名姓名
	IdCard               string  `json:"id_card"`                // 身份证号
	RealNameStatus       string  `json:"real_name_status"`       // 实名状态（pending/approved/rejected）
}

type AgentMembershipConfigListItem struct {
	Id                       int64    `json:"id"`                          // 主键
	LevelName                string   `json:"level_name"`                  // 会员级别名称
	Price                    *float64 `json:"price"`                       // 会员年费
	ReportCommission         *float64 `json:"report_commission"`           // 直推报告收益
	LowerActivityReward      *float64 `json:"lower_activity_reward"`       // 下级活跃奖励金额
	NewActivityReward        *float64 `json:"new_activity_reward"`         // 新增活跃奖励金额
	LowerStandardCount       *int64   `json:"lower_standard_count"`        // 活跃下级达标个数
	NewLowerStandardCount    *int64   `json:"new_lower_standard_count"`    // 新增活跃下级达标个数
	LowerWithdrawRewardRatio *float64 `json:"lower_withdraw_reward_ratio"` // 下级提现奖励比例
	LowerConvertVipReward    *float64 `json:"lower_convert_vip_reward"`    // 下级转化VIP奖励
	LowerConvertSvipReward   *float64 `json:"lower_convert_svip_reward"`   // 下级转化SVIP奖励
	ExemptionAmount          *float64 `json:"exemption_amount"`            // 免责金额
	PriceIncreaseMax         *float64 `json:"price_increase_max"`          // 提价最高金额
	PriceRatio               *float64 `json:"price_ratio"`                 // 提价区间收取比例
	PriceIncreaseAmount      *float64 `json:"price_increase_amount"`       // 在原本成本上加价的金额
	CreateTime               string   `json:"create_time"`                 // 创建时间
}

type AgentMembershipProductConfigReq struct {
	ProductID int64 `form:"product_id"`
}

type AgentMembershipProductConfigResp struct {
	AgentMembershipUserConfig AgentMembershipUserConfig `json:"agent_membership_user_config"`
	ProductConfig             ProductConfig             `json:"product_config"`
	PriceIncreaseMax          float64                   `json:"price_increase_max"`
	PriceIncreaseAmount       float64                   `json:"price_increase_amount"`
	PriceRatio                float64                   `json:"price_ratio"`
}

type AgentMembershipRechargeOrderListItem struct {
	Id              int64   `json:"id"`                // 主键
	UserId          int64   `json:"user_id"`           // 用户ID
	AgentId         int64   `json:"agent_id"`          // 代理ID
	LevelName       string  `json:"level_name"`        // 等级名称
	Amount          float64 `json:"amount"`            // 金额
	PaymentMethod   string  `json:"payment_method"`    // 支付方式
	OrderNo         string  `json:"order_no"`          // 订单号
	PlatformOrderId string  `json:"platform_order_id"` // 平台订单号
	Status          string  `json:"status"`            // 状态
	CreateTime      string  `json:"create_time"`       // 创建时间
}

type AgentMembershipUserConfig struct {
	ProductID           int64   `json:"product_id"`
	PriceIncreaseAmount float64 `json:"price_increase_amount"`
	PriceRangeFrom      float64 `json:"price_range_from"`
	PriceRangeTo        float64 `json:"price_range_to"`
	PriceRatio          float64 `json:"price_ratio"`
}

type AgentPlatformDeductionListItem struct {
	Id         int64   `json:"id"`          // 主键
	AgentId    int64   `json:"agent_id"`    // 代理ID
	Amount     float64 `json:"amount"`      // 金额
	Type       string  `json:"type"`        // 类型（cost/pricing）
	Status     int64   `json:"status"`      // 状态
	CreateTime string  `json:"create_time"` // 创建时间
}

type AgentProductConfig struct {
	ProductID         int64   `json:"product_id"`
	CostPrice         float64 `json:"cost_price"`
	PriceRangeMin     float64 `json:"price_range_min"`
	PriceRangeMax     float64 `json:"price_range_max"`
	PPricingStandard  float64 `json:"p_pricing_standard"`
	POverpricingRatio float64 `json:"p_overpricing_ratio"`
	APricingStandard  float64 `json:"a_pricing_standard"`
	APricingEnd       float64 `json:"a_pricing_end"`
	AOverpricingRatio float64 `json:"a_overpricing_ratio"`
}

type AgentProductConfigResp struct {
	AgentProductConfig []AgentProductConfig
}

type AgentProductionConfigItem struct {
	Id               int64   `json:"id"`                // 主键
	ProductName      string  `json:"product_name"`      // 产品名
	CostPrice        float64 `json:"cost_price"`        // 成本
	PriceRangeMin    float64 `json:"price_range_min"`   // 最低定价
	PriceRangeMax    float64 `json:"price_range_max"`   // 最高定价
	PricingStandard  float64 `json:"pricing_standard"`  // 定价标准
	OverpricingRatio float64 `json:"overpricing_ratio"` // 超价比例
	CreateTime       string  `json:"create_time"`       // 创建时间
}

type AgentRealNameReq struct {
	Name   string `json:"name"`
	IDCard string `json:"id_card"`
	Mobile string `json:"mobile"`
	Code   string `json:"code"`
}

type AgentRealNameResp struct {
	Status string `json:"status"`
}

type AgentRewardListItem struct {
	Id              int64   `json:"id"`                // 主键
	AgentId         int64   `json:"agent_id"`          // 代理ID
	RelationAgentId int64   `json:"relation_agent_id"` // 关联代理ID
	Amount          float64 `json:"amount"`            // 金额
	Type            string  `json:"type"`              // 奖励类型
	CreateTime      string  `json:"create_time"`       // 创建时间
}

type AgentSubordinateContributionDetail struct {
	ID         int64   `json:"id"`
	CreateTime string  `json:"create_time"`
	Amount     float64 `json:"amount"`
	Type       string  `json:"type"`
}

type AgentSubordinateContributionStats struct {
	CostCount                   int64   `json:"cost_count"`                     // 成本扣除次数
	CostAmount                  float64 `json:"cost_amount"`                    // 成本扣除总额
	PricingCount                int64   `json:"pricing_count"`                  // 定价扣除次数
	PricingAmount               float64 `json:"pricing_amount"`                 // 定价扣除总额
	DescendantPromotionCount    int64   `json:"descendant_promotion_count"`     // 下级推广次数
	DescendantPromotionAmount   float64 `json:"descendant_promotion_amount"`    // 下级推广总额
	DescendantUpgradeVipCount   int64   `json:"descendant_upgrade_vip_count"`   // 下级升级VIP次数
	DescendantUpgradeVipAmount  float64 `json:"descendant_upgrade_vip_amount"`  // 下级升级VIP总额
	DescendantUpgradeSvipCount  int64   `json:"descendant_upgrade_svip_count"`  // 下级升级SVIP次数
	DescendantUpgradeSvipAmount float64 `json:"descendant_upgrade_svip_amount"` // 下级升级SVIP总额
	DescendantStayActiveCount   int64   `json:"descendant_stay_active_count"`   // 下级保持活跃次数
	DescendantStayActiveAmount  float64 `json:"descendant_stay_active_amount"`  // 下级保持活跃总额
	DescendantNewActiveCount    int64   `json:"descendant_new_active_count"`    // 下级新增活跃次数
	DescendantNewActiveAmount   float64 `json:"descendant_new_active_amount"`   // 下级新增活跃总额
	DescendantWithdrawCount     int64   `json:"descendant_withdraw_count"`      // 下级提现次数
	DescendantWithdrawAmount    float64 `json:"descendant_withdraw_amount"`     // 下级提现总额
}

type AgentSubordinateList struct {
	ID                int64   `json:"id"`
	Mobile            string  `json:"mobile"`
	CreateTime        string  `json:"create_time"`
	LevelName         string  `json:"level_name"`
	TotalOrders       int64   `json:"total_orders"`       // 总单量
	TotalEarnings     float64 `json:"total_earnings"`     // 总金额
	TotalContribution float64 `json:"total_contribution"` // 总贡献
}

type AgentWithdrawalListItem struct {
	Id           int64   `json:"id"`            // 主键
	AgentId      int64   `json:"agent_id"`      // 代理ID
	WithdrawNo   string  `json:"withdraw_no"`   // 提现单号
	Amount       float64 `json:"amount"`        // 金额
	Status       int64   `json:"status"`        // 状态
	PayeeAccount string  `json:"payee_account"` // 收款账户
	Remark       string  `json:"remark"`        // 备注
	CreateTime   string  `json:"create_time"`   // 创建时间
}

type BindMobileReq struct {
	Mobile string `json:"mobile" validate:"required,mobile"`
	Code   string `json:"code" validate:"required"`
}

type BindMobileResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type Commission struct {
	ProductName string  `json:"product_name"`
	Amount      float64 `json:"amount"`
	CreateTime  string  `json:"create_time"`
}

type CreateMenuReq struct {
	Pid       int64                  `json:"pid,optional"`              // 父菜单ID
	Name      string                 `json:"name"`                      // 路由名称
	Path      string                 `json:"path,optional"`             // 路由路径
	Component string                 `json:"component,optional"`        // 组件路径
	Redirect  string                 `json:"redirect,optional"`         // 重定向路径
	Meta      map[string]interface{} `json:"meta"`                      // 路由元数据
	Status    int64                  `json:"status,optional,default=1"` // 状态：0-禁用，1-启用
	Type      string                 `json:"type"`                      // 类型
	Sort      int64                  `json:"sort,optional"`             // 排序
}

type CreateMenuResp struct {
	Id int64 `json:"id"` // 菜单ID
}

type CreatePromotionLinkReq struct {
	Name string `json:"name"` // 链接名称
}

type CreatePromotionLinkResp struct {
	Id  int64  `json:"id"`  // 链接ID
	Url string `json:"url"` // 生成的推广链接URL
}

type CreateRoleReq struct {
	RoleName    string  `json:"role_name"`        // 角色名称
	RoleCode    string  `json:"role_code"`        // 角色编码
	Description string  `json:"description"`      // 角色描述
	Status      int64   `json:"status,default=1"` // 状态：0-禁用，1-启用
	Sort        int64   `json:"sort,default=0"`   // 排序
	MenuIds     []int64 `json:"menu_ids"`         // 关联的菜单ID列表
}

type CreateRoleResp struct {
	Id int64 `json:"id"` // 角色ID
}

type DeleteMenuReq struct {
	Id int64 `path:"id"` // 菜单ID
}

type DeleteMenuResp struct {
	Success bool `json:"success"` // 是否成功
}

type DeletePromotionLinkReq struct {
	Id int64 `path:"id"` // 链接ID
}

type DeletePromotionLinkResp struct {
	Success bool `json:"success"` // 是否成功
}

type DeleteRoleReq struct {
	Id int64 `path:"id"` // 角色ID
}

type DeleteRoleResp struct {
	Success bool `json:"success"` // 是否成功
}

type DirectPushReport struct {
	TotalCommission float64         `json:"total_commission"`
	TotalReport     int             `json:"total_report"`
	Today           TimeRangeReport `json:"today"`   // 近24小时数据
	Last7D          TimeRangeReport `json:"last7d"`  // 近7天数据
	Last30D         TimeRangeReport `json:"last30d"` // 近30天数据
}

type Feature struct {
	ID    int64  `json:"id"`     // 功能ID
	ApiID string `json:"api_id"` // API标识
	Name  string `json:"name"`   // 功能描述
}

type FeatureListItem struct {
	Id         int64  `json:"id"`          // 功能ID
	ApiId      string `json:"api_id"`      // API标识
	Name       string `json:"name"`        // 描述
	CreateTime string `json:"create_time"` // 创建时间
	UpdateTime string `json:"update_time"` // 更新时间
}

type GetAgentRevenueInfoReq struct {
}

type GetAgentRevenueInfoResp struct {
	Balance       float64          `json:"balance"`
	FrozenBalance float64          `json:"frozen_balance"`
	TotalEarnings float64          `json:"total_earnings"`
	DirectPush    DirectPushReport `json:"direct_push"`   // 直推报告数据
	ActiveReward  ActiveReward     `json:"active_reward"` // 活跃下级奖励数据
}

type GetAgentSubordinateContributionDetailReq struct {
	Page          int64 `form:"page"`           // 页码
	PageSize      int64 `form:"page_size"`      // 每页数据量
	SubordinateID int64 `form:"subordinate_id"` // 下级ID
}

type GetAgentSubordinateContributionDetailResp struct {
	Mobile            string                               `json:"mobile"`
	Total             int64                                `json:"total"` // 总记录数
	CreateTime        string                               `json:"create_time"`
	TotalEarnings     float64                              `json:"total_earnings"`     // 总金额
	TotalContribution float64                              `json:"total_contribution"` // 总贡献
	TotalOrders       int64                                `json:"total_orders"`       // 总单量
	LevelName         string                               `json:"level_name"`         // 等级名称
	List              []AgentSubordinateContributionDetail `json:"list"`               // 查询列表
	Stats             AgentSubordinateContributionStats    `json:"stats"`              // 统计数据
}

type GetAgentSubordinateListReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type GetAgentSubordinateListResp struct {
	Total int64                  `json:"total"` // 总记录数
	List  []AgentSubordinateList `json:"list"`  // 查询列表
}

type GetCommissionReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type GetCommissionResp struct {
	Total int64        `json:"total"` // 总记录数
	List  []Commission `json:"list"`  // 查询列表
}

type GetLinkDataReq struct {
	LinkIdentifier string `form:"link_identifier"`
}

type GetLinkDataResp struct {
	Product
}

type GetMenuAllReq struct {
}

type GetMenuAllResp struct {
	Name      string                 `json:"name"`
	Path      string                 `json:"path"`
	Redirect  string                 `json:"redirect,omitempty"`
	Component string                 `json:"component,omitempty"`
	Sort      int64                  `json:"sort"`
	Meta      map[string]interface{} `json:"meta"`
	Children  []GetMenuAllResp       `json:"children"`
}

type GetMenuDetailReq struct {
	Id int64 `path:"id"` // 菜单ID
}

type GetMenuDetailResp struct {
	Id         int64                  `json:"id"`         // 菜单ID
	Pid        int64                  `json:"pid"`        // 父菜单ID
	Name       string                 `json:"name"`       // 路由名称
	Path       string                 `json:"path"`       // 路由路径
	Component  string                 `json:"component"`  // 组件路径
	Redirect   string                 `json:"redirect"`   // 重定向路径
	Meta       map[string]interface{} `json:"meta"`       // 路由元数据
	Status     int64                  `json:"status"`     // 状态：0-禁用，1-启用
	Type       string                 `json:"type"`       // 类型
	Sort       int64                  `json:"sort"`       // 排序
	CreateTime string                 `json:"createTime"` // 创建时间
	UpdateTime string                 `json:"updateTime"` // 更新时间
}

type GetMenuListReq struct {
	Name   string `form:"name,optional"`              // 菜单名称
	Path   string `form:"path,optional"`              // 路由路径
	Status int64  `form:"status,optional,default=-1"` // 状态：0-禁用，1-启用
	Type   string `form:"type,optional"`              // 类型
}

type GetNotificationsResp struct {
	Notifications []Notification `json:"notifications"` // 通知列表
	Total         int64          `json:"total"`         // 总记录数
}

type GetProductByEnRequest struct {
	ProductEn string `path:"product_en"`
}

type GetProductByIDRequest struct {
	Id int64 `path:"id"`
}

type GetPromotionLinkDetailReq struct {
	Id int64 `path:"id"` // 链接ID
}

type GetPromotionLinkDetailResp struct {
	Name          string `json:"name"`                     // 链接名称
	Url           string `json:"url"`                      // 推广链接URL
	ClickCount    int64  `json:"click_count"`              // 点击数
	PayCount      int64  `json:"pay_count"`                // 付费次数
	PayAmount     string `json:"pay_amount"`               // 付费金额
	CreateTime    string `json:"create_time"`              // 创建时间
	UpdateTime    string `json:"update_time"`              // 更新时间
	LastClickTime string `json:"last_click_time,optional"` // 最后点击时间
	LastPayTime   string `json:"last_pay_time,optional"`   // 最后付费时间
}

type GetPromotionLinkListReq struct {
	Page     int64  `form:"page,default=1"`      // 页码
	PageSize int64  `form:"pageSize,default=20"` // 每页数量
	Name     string `form:"name,optional"`       // 链接名称
	Url      string `form:"url,optional"`        // 推广链接URL
}

type GetPromotionLinkListResp struct {
	Total int64               `json:"total"` // 总数
	Items []PromotionLinkItem `json:"items"` // 列表
}

type GetPromotionStatsHistoryReq struct {
	StartDate string `form:"start_date"` // 开始日期，格式：YYYY-MM-DD
	EndDate   string `form:"end_date"`   // 结束日期，格式：YYYY-MM-DD
}

type GetPromotionStatsTotalReq struct {
}

type GetPromotionStatsTotalResp struct {
	TodayPayAmount  float64 `json:"today_pay_amount"`  // 今日金额
	TodayClickCount int64   `json:"today_click_count"` // 今日点击数
	TodayPayCount   int64   `json:"today_pay_count"`   // 今日付费次数
	TotalPayAmount  float64 `json:"total_pay_amount"`  // 总金额
	TotalClickCount int64   `json:"total_click_count"` // 总点击数
	TotalPayCount   int64   `json:"total_pay_count"`   // 总付费次数
}

type GetRewardsReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type GetRewardsResp struct {
	Total int64     `json:"total"` // 总记录数
	List  []Rewards `json:"list"`  // 查询列表
}

type GetRoleDetailReq struct {
	Id int64 `path:"id"` // 角色ID
}

type GetRoleDetailResp struct {
	Id          int64   `json:"id"`          // 角色ID
	RoleName    string  `json:"role_name"`   // 角色名称
	RoleCode    string  `json:"role_code"`   // 角色编码
	Description string  `json:"description"` // 角色描述
	Status      int64   `json:"status"`      // 状态：0-禁用，1-启用
	Sort        int64   `json:"sort"`        // 排序
	CreateTime  string  `json:"create_time"` // 创建时间
	UpdateTime  string  `json:"update_time"` // 更新时间
	MenuIds     []int64 `json:"menu_ids"`    // 关联的菜单ID列表
}

type GetRoleListReq struct {
	Page     int64  `form:"page,default=1"`             // 页码
	PageSize int64  `form:"pageSize,default=20"`        // 每页数量
	Name     string `form:"name,optional"`              // 角色名称
	Code     string `form:"code,optional"`              // 角色编码
	Status   int64  `form:"status,optional,default=-1"` // 状态：0-禁用，1-启用
}

type GetRoleListResp struct {
	Total int64          `json:"total"` // 总数
	Items []RoleListItem `json:"items"` // 列表
}

type GetWithdrawalReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type GetWithdrawalResp struct {
	Total int64        `json:"total"` // 总记录数
	List  []Withdrawal `json:"list"`  // 查询列表
}

type GetWithdrawalTaxExemptionReq struct {
}

type GetWithdrawalTaxExemptionResp struct {
	TotalExemptionAmount     float64 `json:"total_exemption_amount"`
	UsedExemptionAmount      float64 `json:"used_exemption_amount"`
	RemainingExemptionAmount float64 `json:"remaining_exemption_amount"`
	TaxRate                  float64 `json:"tax_rate"`
}

type HealthCheckResp struct {
	Status  string `json:"status"`  // 服务状态
	Message string `json:"message"` // 状态信息
}

type IapCallbackReq struct {
	OrderID            int64  `json:"order_id" validate:"required"`
	TransactionReceipt string `json:"transaction_receipt" validate:"required"`
}

type MenuListItem struct {
	Id         int64                  `json:"id"`         // 菜单ID
	Pid        int64                  `json:"pid"`        // 父菜单ID
	Name       string                 `json:"name"`       // 路由名称
	Path       string                 `json:"path"`       // 路由路径
	Component  string                 `json:"component"`  // 组件路径
	Redirect   string                 `json:"redirect"`   // 重定向路径
	Meta       map[string]interface{} `json:"meta"`       // 路由元数据
	Status     int64                  `json:"status"`     // 状态：0-禁用，1-启用
	Type       string                 `json:"type"`       // 类型
	Sort       int64                  `json:"sort"`       // 排序
	CreateTime string                 `json:"createTime"` // 创建时间
	Children   []MenuListItem         `json:"children"`   // 子菜单
}

type MobileCodeLoginReq struct {
	Mobile string `json:"mobile"`
	Code   string `json:"code" validate:"required"`
}

type MobileCodeLoginResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type Notification struct {
	Title            string `json:"title"`            // 通知标题
	Content          string `json:"content"`          // 通知内容 (富文本)
	NotificationPage string `json:"notificationPage"` // 通知页面
	StartDate        string `json:"startDate"`        // 通知开始日期，格式 "YYYY-MM-DD"
	EndDate          string `json:"endDate"`          // 通知结束日期，格式 "YYYY-MM-DD"
	StartTime        string `json:"startTime"`        // 每天通知开始时间，格式 "HH:MM:SS"
	EndTime          string `json:"endTime"`          // 每天通知结束时间，格式 "HH:MM:SS"
}

type NotificationListItem struct {
	Id               int64  `json:"id"`                // 通知ID
	Title            string `json:"title"`             // 通知标题
	NotificationPage string `json:"notification_page"` // 通知页面
	Content          string `json:"content"`           // 通知内容
	StartDate        string `json:"start_date"`        // 生效开始日期
	StartTime        string `json:"start_time"`        // 生效开始时间
	EndDate          string `json:"end_date"`          // 生效结束日期
	EndTime          string `json:"end_time"`          // 生效结束时间
	Status           int64  `json:"status"`            // 状态
	CreateTime       string `json:"create_time"`       // 创建时间
	UpdateTime       string `json:"update_time"`       // 更新时间
}

type OrderListItem struct {
	Id              int64   `json:"id"`                // 订单ID
	OrderNo         string  `json:"order_no"`          // 商户订单号
	PlatformOrderId string  `json:"platform_order_id"` // 支付订单号
	ProductName     string  `json:"product_name"`      // 产品名称
	PaymentPlatform string  `json:"payment_platform"`  // 支付方式
	PaymentScene    string  `json:"payment_scene"`     // 支付平台
	Amount          float64 `json:"amount"`            // 金额
	Status          string  `json:"status"`            // 支付状态：pending-待支付，paid-已支付，refunded-已退款，closed-已关闭，failed-支付失败
	QueryState      string  `json:"query_state"`       // 查询状态：pending-待查询，success-查询成功，failed-查询失败 processing-查询中
	CreateTime      string  `json:"create_time"`       // 创建时间
	PayTime         string  `json:"pay_time"`          // 支付时间
	RefundTime      string  `json:"refund_time"`       // 退款时间
	IsPromotion     int64   `json:"is_promotion"`      // 是否推广订单：0-否，1-是
}

type PaymentCheckReq struct {
	OrderNo string `json:"order_no" validate:"required"`
}

type PaymentCheckResp struct {
	Type   string `json:"type"`
	Status string `json:"status"`
}

type PaymentReq struct {
	Id        string `json:"id"`
	PayMethod string `json:"pay_method"`
	PayType   string `json:"pay_type" validate:"required,oneof=query agent_vip"`
}

type PaymentResp struct {
	PrepayData interface{} `json:"prepay_data"`
	PrepayId   string      `json:"prepay_id"`
	OrderNo    string      `json:"order_no"`
}

type PlatformUserListItem struct {
	Id         int64  `json:"id"`          // 用户ID
	Mobile     string `json:"mobile"`      // 手机号
	Nickname   string `json:"nickname"`    // 昵称
	Info       string `json:"info"`        // 备注信息
	Inside     int64  `json:"inside"`      // 是否内部用户 1-是 0-否
	CreateTime string `json:"create_time"` // 创建时间
	UpdateTime string `json:"update_time"` // 更新时间
}

type Product struct {
	ProductName string    `json:"product_name"`
	ProductEn   string    `json:"product_en"`
	Description string    `json:"description"`
	Notes       string    `json:"notes,optional"`
	SellPrice   float64   `json:"sell_price"`
	Features    []Feature `json:"features"` // 关联功能列表
}

type ProductConfig struct {
	ProductID     int64   `json:"product_id"`
	CostPrice     float64 `json:"cost_price"`
	PriceRangeMin float64 `json:"price_range_min"`
	PriceRangeMax float64 `json:"price_range_max"`
}

type ProductFeatureItem struct {
	FeatureId   int64 `json:"feature_id"`   // 功能ID
	Sort        int64 `json:"sort"`         // 排序
	Enable      int64 `json:"enable"`       // 是否启用
	IsImportant int64 `json:"is_important"` // 是否重要
}

type ProductListItem struct {
	Id          int64   `json:"id"`           // 产品ID
	ProductName string  `json:"product_name"` // 服务名
	ProductEn   string  `json:"product_en"`   // 英文名
	Description string  `json:"description"`  // 描述
	Notes       string  `json:"notes"`        // 备注
	CostPrice   float64 `json:"cost_price"`   // 成本
	SellPrice   float64 `json:"sell_price"`   // 售价
	CreateTime  string  `json:"create_time"`  // 创建时间
	UpdateTime  string  `json:"update_time"`  // 更新时间
}

type ProductResponse struct {
	Product
}

type PromotionLinkItem struct {
	Id            int64  `json:"id"`                       // 链接ID
	Name          string `json:"name"`                     // 链接名称
	Url           string `json:"url"`                      // 推广链接URL
	ClickCount    int64  `json:"click_count"`              // 点击数
	PayCount      int64  `json:"pay_count"`                // 付费次数
	PayAmount     string `json:"pay_amount"`               // 付费金额
	CreateTime    string `json:"create_time"`              // 创建时间
	LastClickTime string `json:"last_click_time,optional"` // 最后点击时间
	LastPayTime   string `json:"last_pay_time,optional"`   // 最后付费时间
}

type PromotionStatsHistoryItem struct {
	Id         int64   `json:"id"`          // 记录ID
	LinkId     int64   `json:"link_id"`     // 链接ID
	PayAmount  float64 `json:"pay_amount"`  // 金额
	ClickCount int64   `json:"click_count"` // 点击数
	PayCount   int64   `json:"pay_count"`   // 付费次数
	StatsDate  string  `json:"stats_date"`  // 统计日期
}

type Query struct {
	Id          int64                  `json:"id"`           // 主键ID
	OrderId     int64                  `json:"order_id"`     // 订单ID
	UserId      int64                  `json:"user_id"`      // 用户ID
	ProductName string                 `json:"product_name"` // 产品ID
	QueryParams map[string]interface{} `json:"query_params"`
	QueryData   []QueryItem            `json:"query_data"`
	CreateTime  string                 `json:"create_time"` // 创建时间
	UpdateTime  string                 `json:"update_time"` // 更新时间
	QueryState  string                 `json:"query_state"` // 查询状态
}

type QueryCleanupConfigItem struct {
	Id          int64  `json:"id"`           // 主键ID
	ConfigKey   string `json:"config_key"`   // 配置键
	ConfigValue string `json:"config_value"` // 配置值
	ConfigDesc  string `json:"config_desc"`  // 配置描述
	Status      int64  `json:"status"`       // 状态：1-启用，0-禁用
	CreateTime  string `json:"create_time"`  // 创建时间
	UpdateTime  string `json:"update_time"`  // 更新时间
}

type QueryCleanupDetailItem struct {
	Id            int64  `json:"id"`              // 主键ID
	CleanupLogId  int64  `json:"cleanup_log_id"`  // 清理日志ID
	QueryId       int64  `json:"query_id"`        // 查询ID
	OrderId       int64  `json:"order_id"`        // 订单ID
	UserId        int64  `json:"user_id"`         // 用户ID
	ProductName   string `json:"product_name"`    // 产品名称
	QueryState    string `json:"query_state"`     // 查询状态
	CreateTimeOld string `json:"create_time_old"` // 原创建时间
	CreateTime    string `json:"create_time"`     // 创建时间
}

type QueryCleanupLogItem struct {
	Id            int64  `json:"id"`             // 主键ID
	CleanupTime   string `json:"cleanup_time"`   // 清理时间
	CleanupBefore string `json:"cleanup_before"` // 清理截止时间
	Status        int64  `json:"status"`         // 状态：1-成功，2-失败
	AffectedRows  int64  `json:"affected_rows"`  // 影响行数
	ErrorMsg      string `json:"error_msg"`      // 错误信息
	Remark        string `json:"remark"`         // 备注
	CreateTime    string `json:"create_time"`    // 创建时间
}

type QueryDetailByOrderIdReq struct {
	OrderId int64 `path:"order_id"`
}

type QueryDetailByOrderIdResp struct {
	Query
}

type QueryDetailByOrderNoReq struct {
	OrderNo string `path:"order_no"`
}

type QueryDetailByOrderNoResp struct {
	Query
}

type QueryExampleReq struct {
	Feature string `form:"feature"`
}

type QueryExampleResp struct {
	Query
}

type QueryGenerateShareLinkReq struct {
	OrderId *int64  `json:"order_id,optional"`
	OrderNo *string `json:"order_no,optional"`
}

type QueryGenerateShareLinkResp struct {
	ShareLink string `json:"share_link"`
}

type QueryItem struct {
	Feature interface{} `json:"feature"`
	Data    interface{} `json:"data"` // 这里可以是 map 或 具体的 struct
}

type QueryListReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type QueryListResp struct {
	Total int64   `json:"total"` // 总记录数
	List  []Query `json:"list"`  // 查询列表
}

type QueryProvisionalOrderReq struct {
	Id string `path:"id"`
}

type QueryProvisionalOrderResp struct {
	Name    string  `json:"name"`
	IdCard  string  `json:"id_card"`
	Mobile  string  `json:"mobile"`
	Product Product `json:"product"`
}

type QueryReq struct {
	Data string `json:"data" validate:"required"`
}

type QueryResp struct {
	Id string `json:"id"`
}

type QueryRetryReq struct {
	Id int64 `path:"id"`
}

type QueryRetryResp struct {
	Query
}

type QueryServiceReq struct {
	Product         string `path:"product"`
	Data            string `json:"data" validate:"required"`
	AgentIdentifier string `json:"agent_identifier,optional"`
	App             bool   `json:"app,optional"`
}

type QueryServiceResp struct {
	Id           string `json:"id"`
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type QueryShareDetailReq struct {
	Id string `path:"id"`
}

type QueryShareDetailResp struct {
	Status string `json:"status"`
	Query
}

type QuerySingleTestReq struct {
	Params map[string]interface{} `json:"params"`
	Api    string                 `json:"api"`
}

type QuerySingleTestResp struct {
	Data interface{} `json:"data"`
	Api  string      `json:"api"`
}

type RecordLinkClickReq struct {
	Path string `path:"path"` // 链接路径
}

type RecordLinkClickResp struct {
	Success bool `json:"success"` // 是否成功
}

type Rewards struct {
	Type       string  `json:"type"`
	Amount     float64 `json:"amount"`
	CreateTime string  `json:"create_time"`
}

type RoleListItem struct {
	Id          int64   `json:"id"`          // 角色ID
	RoleName    string  `json:"role_name"`   // 角色名称
	RoleCode    string  `json:"role_code"`   // 角色编码
	Description string  `json:"description"` // 角色描述
	Status      int64   `json:"status"`      // 状态：0-禁用，1-启用
	Sort        int64   `json:"sort"`        // 排序
	CreateTime  string  `json:"create_time"` // 创建时间
	MenuIds     []int64 `json:"menu_ids"`    // 关联的菜单ID列表
}

type SaveAgentMembershipUserConfigReq struct {
	ProductID           int64   `json:"product_id"`
	PriceIncreaseAmount float64 `json:"price_increase_amount"`
	PriceRangeFrom      float64 `json:"price_range_from"`
	PriceRangeTo        float64 `json:"price_range_to"`
	PriceRatio          float64 `json:"price_ratio"`
}

type TimeRangeReport struct {
	Commission float64 `json:"commission"` // 佣金
	Report     int     `json:"report"`     // 报告量
}

type UpdateMenuReq struct {
	Id        int64                  `path:"id"`                 // 菜单ID
	Pid       int64                  `json:"pid,optional"`       // 父菜单ID
	Name      string                 `json:"name"`               // 路由名称
	Path      string                 `json:"path,optional"`      // 路由路径
	Component string                 `json:"component,optional"` // 组件路径
	Redirect  string                 `json:"redirect,optional"`  // 重定向路径
	Meta      map[string]interface{} `json:"meta"`               // 路由元数据
	Status    int64                  `json:"status,optional"`    // 状态：0-禁用，1-启用
	Type      string                 `json:"type"`               // 类型
	Sort      int64                  `json:"sort,optional"`      // 排序
}

type UpdateMenuResp struct {
	Success bool `json:"success"` // 是否成功
}

type UpdatePromotionLinkReq struct {
	Id   int64   `path:"id"`            // 链接ID
	Name *string `json:"name,optional"` // 链接名称
}

type UpdatePromotionLinkResp struct {
	Success bool `json:"success"` // 是否成功
}

type UpdateQueryDataReq struct {
	Id        int64  `json:"id"`         // 查询ID
	QueryData string `json:"query_data"` // 查询数据(未加密的JSON)
}

type UpdateQueryDataResp struct {
	Id        int64  `json:"id"`
	UpdatedAt string `json:"updated_at"` // 更新时间
}

type UpdateRoleReq struct {
	Id          int64   `path:"id"`                   // 角色ID
	RoleName    *string `json:"role_name,optional"`   // 角色名称
	RoleCode    *string `json:"role_code,optional"`   // 角色编码
	Description *string `json:"description,optional"` // 角色描述
	Status      *int64  `json:"status,optional"`      // 状态：0-禁用，1-启用
	Sort        *int64  `json:"sort,optional"`        // 排序
	MenuIds     []int64 `json:"menu_ids,optional"`    // 关联的菜单ID列表
}

type UpdateRoleResp struct {
	Success bool `json:"success"` // 是否成功
}

type User struct {
	Id       int64  `json:"id"`
	Mobile   string `json:"mobile"`
	NickName string `json:"nickName"`
	UserType int64  `json:"userType"`
}

type UserInfoResp struct {
	UserInfo User `json:"userInfo"`
}

type WXH5AuthReq struct {
	Code string `json:"code"`
}

type WXH5AuthResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type WXMiniAuthReq struct {
	Code          string `json:"code"`
	IV            string `json:"iv"`
	EncryptedData string `json:"encryptedData"`
}

type WXMiniAuthResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type Withdrawal struct {
	Status       int64   `json:"status"`
	Amount       float64 `json:"amount"`
	WithdrawalNo string  `json:"withdrawal_no"`
	Remark       string  `json:"remark"`
	PayeeAccount string  `json:"payee_account"`
	CreateTime   string  `json:"create_time"`
}

type WithdrawalReq struct {
	Amount       float64 `json:"amount"` // 提现金额
	PayeeAccount string  `json:"payee_account"`
	PayeeName    string  `json:"payee_name"`
}

type WithdrawalResp struct {
	Status  int64  `json:"status"` // 1申请中  2成功  3失败
	FailMsg string `json:"fail_msg"`
}

type GetAppVersionResp struct {
	Version string `json:"version"`
	WgtUrl  string `json:"wgtUrl"`
}

type SendSmsReq struct {
	Mobile     string `json:"mobile" validate:"required,mobile"`
	ActionType string `json:"actionType" validate:"required,oneof=login register query agentApply realName bindMobile"`
}
