package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentActiveStatModel = (*customAgentActiveStatModel)(nil)

type (
	// AgentActiveStatModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentActiveStatModel.
	AgentActiveStatModel interface {
		agentActiveStatModel
	}

	customAgentActiveStatModel struct {
		*defaultAgentActiveStatModel
	}
)

// NewAgentActiveStatModel returns a model for the database table.
func NewAgentActiveStatModel(conn sqlx.SqlConn, c cache.CacheConf) AgentActiveStatModel {
	return &customAgentActiveStatModel{
		defaultAgentActiveStatModel: newAgentActiveStatModel(conn, c),
	}
}
