package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentAuditModel = (*customAgentAuditModel)(nil)

type (
	// AgentAuditModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentAuditModel.
	AgentAuditModel interface {
		agentAuditModel
	}

	customAgentAuditModel struct {
		*defaultAgentAuditModel
	}
)

// NewAgentAuditModel returns a model for the database table.
func NewAgentAuditModel(conn sqlx.SqlConn, c cache.CacheConf) AgentAuditModel {
	return &customAgentAuditModel{
		defaultAgentAuditModel: newAgentAuditModel(conn, c),
	}
}
