package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentCommissionDeductionModel = (*customAgentCommissionDeductionModel)(nil)

type (
	// AgentCommissionDeductionModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentCommissionDeductionModel.
	AgentCommissionDeductionModel interface {
		agentCommissionDeductionModel
	}

	customAgentCommissionDeductionModel struct {
		*defaultAgentCommissionDeductionModel
	}
)

// NewAgentCommissionDeductionModel returns a model for the database table.
func NewAgentCommissionDeductionModel(conn sqlx.SqlConn, c cache.CacheConf) AgentCommissionDeductionModel {
	return &customAgentCommissionDeductionModel{
		defaultAgentCommissionDeductionModel: newAgentCommissionDeductionModel(conn, c),
	}
}
