package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentCommissionModel = (*customAgentCommissionModel)(nil)

type (
	// AgentCommissionModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentCommissionModel.
	AgentCommissionModel interface {
		agentCommissionModel
	}

	customAgentCommissionModel struct {
		*defaultAgentCommissionModel
	}
)

// NewAgentCommissionModel returns a model for the database table.
func NewAgentCommissionModel(conn sqlx.SqlConn, c cache.CacheConf) AgentCommissionModel {
	return &customAgentCommissionModel{
		defaultAgentCommissionModel: newAgentCommissionModel(conn, c),
	}
}
