package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentLinkModel = (*customAgentLinkModel)(nil)

type (
	// AgentLinkModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentLinkModel.
	AgentLinkModel interface {
		agentLinkModel
	}

	customAgentLinkModel struct {
		*defaultAgentLinkModel
	}
)

// NewAgentLinkModel returns a model for the database table.
func NewAgentLinkModel(conn sqlx.SqlConn, c cache.CacheConf) AgentLinkModel {
	return &customAgentLinkModel{
		defaultAgentLinkModel: newAgentLinkModel(conn, c),
	}
}
