package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentMembershipConfigModel = (*customAgentMembershipConfigModel)(nil)

type (
	// AgentMembershipConfigModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentMembershipConfigModel.
	AgentMembershipConfigModel interface {
		agentMembershipConfigModel
	}

	customAgentMembershipConfigModel struct {
		*defaultAgentMembershipConfigModel
	}
)

// NewAgentMembershipConfigModel returns a model for the database table.
func NewAgentMembershipConfigModel(conn sqlx.SqlConn, c cache.CacheConf) AgentMembershipConfigModel {
	return &customAgentMembershipConfigModel{
		defaultAgentMembershipConfigModel: newAgentMembershipConfigModel(conn, c),
	}
}
