package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentModel = (*customAgentModel)(nil)

type (
	// AgentModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentModel.
	AgentModel interface {
		agentModel
	}

	customAgentModel struct {
		*defaultAgentModel
	}
)

// NewAgentModel returns a model for the database table.
func NewAgentModel(conn sqlx.SqlConn, c cache.CacheConf) AgentModel {
	return &customAgentModel{
		defaultAgentModel: newAgentModel(conn, c),
	}
}
