package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentOrderModel = (*customAgentOrderModel)(nil)

type (
	// AgentOrderModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentOrderModel.
	AgentOrderModel interface {
		agentOrderModel
	}

	customAgentOrderModel struct {
		*defaultAgentOrderModel
	}
)

// NewAgentOrderModel returns a model for the database table.
func NewAgentOrderModel(conn sqlx.SqlConn, c cache.CacheConf) AgentOrderModel {
	return &customAgentOrderModel{
		defaultAgentOrderModel: newAgentOrderModel(conn, c),
	}
}
