package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentPlatformDeductionModel = (*customAgentPlatformDeductionModel)(nil)

type (
	// AgentPlatformDeductionModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentPlatformDeductionModel.
	AgentPlatformDeductionModel interface {
		agentPlatformDeductionModel
	}

	customAgentPlatformDeductionModel struct {
		*defaultAgentPlatformDeductionModel
	}
)

// NewAgentPlatformDeductionModel returns a model for the database table.
func NewAgentPlatformDeductionModel(conn sqlx.SqlConn, c cache.CacheConf) AgentPlatformDeductionModel {
	return &customAgentPlatformDeductionModel{
		defaultAgentPlatformDeductionModel: newAgentPlatformDeductionModel(conn, c),
	}
}
