package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentProductConfigModel = (*customAgentProductConfigModel)(nil)

type (
	// AgentProductConfigModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentProductConfigModel.
	AgentProductConfigModel interface {
		agentProductConfigModel
	}

	customAgentProductConfigModel struct {
		*defaultAgentProductConfigModel
	}
)

// NewAgentProductConfigModel returns a model for the database table.
func NewAgentProductConfigModel(conn sqlx.SqlConn, c cache.CacheConf) AgentProductConfigModel {
	return &customAgentProductConfigModel{
		defaultAgentProductConfigModel: newAgentProductConfigModel(conn, c),
	}
}
