package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentRewardsModel = (*customAgentRewardsModel)(nil)

type (
	// AgentRewardsModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentRewardsModel.
	AgentRewardsModel interface {
		agentRewardsModel
	}

	customAgentRewardsModel struct {
		*defaultAgentRewardsModel
	}
)

// NewAgentRewardsModel returns a model for the database table.
func NewAgentRewardsModel(conn sqlx.SqlConn, c cache.CacheConf) AgentRewardsModel {
	return &customAgentRewardsModel{
		defaultAgentRewardsModel: newAgentRewardsModel(conn, c),
	}
}
