package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentWalletModel = (*customAgentWalletModel)(nil)

type (
	// AgentWalletModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentWalletModel.
	AgentWalletModel interface {
		agentWalletModel
	}

	customAgentWalletModel struct {
		*defaultAgentWalletModel
	}
)

// NewAgentWalletModel returns a model for the database table.
func NewAgentWalletModel(conn sqlx.SqlConn, c cache.CacheConf) AgentWalletModel {
	return &customAgentWalletModel{
		defaultAgentWalletModel: newAgentWalletModel(conn, c),
	}
}
