package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AgentWithdrawalModel = (*customAgentWithdrawalModel)(nil)

type (
	// AgentWithdrawalModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAgentWithdrawalModel.
	AgentWithdrawalModel interface {
		agentWithdrawalModel
	}

	customAgentWithdrawalModel struct {
		*defaultAgentWithdrawalModel
	}
)

// NewAgentWithdrawalModel returns a model for the database table.
func NewAgentWithdrawalModel(conn sqlx.SqlConn, c cache.CacheConf) AgentWithdrawalModel {
	return &customAgentWithdrawalModel{
		defaultAgentWithdrawalModel: newAgentWithdrawalModel(conn, c),
	}
}
