// Code generated by goctl. DO NOT EDIT!

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"

	"time"

	"github.com/Masterminds/squirrel"
	"github.com/pkg/errors"
	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
	"tydata-server/common/globalkey"
)

var (
	agentWithdrawalTaxExemptionFieldNames          = builder.RawFieldNames(&AgentWithdrawalTaxExemption{})
	agentWithdrawalTaxExemptionRows                = strings.Join(agentWithdrawalTaxExemptionFieldNames, ",")
	agentWithdrawalTaxExemptionRowsExpectAutoSet   = strings.Join(stringx.Remove(agentWithdrawalTaxExemptionFieldNames, "`id`", "`create_time`", "`update_time`"), ",")
	agentWithdrawalTaxExemptionRowsWithPlaceHolder = strings.Join(stringx.Remove(agentWithdrawalTaxExemptionFieldNames, "`id`", "`create_time`", "`update_time`"), "=?,") + "=?"

	cacheTydataAgentWithdrawalTaxExemptionIdPrefix               = "cache:tydata:agentWithdrawalTaxExemption:id:"
	cacheTydataAgentWithdrawalTaxExemptionAgentIdYearMonthPrefix = "cache:tydata:agentWithdrawalTaxExemption:agentId:yearMonth:"
)

type (
	agentWithdrawalTaxExemptionModel interface {
		Insert(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTaxExemption) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*AgentWithdrawalTaxExemption, error)
		FindOneByAgentIdYearMonth(ctx context.Context, agentId int64, yearMonth int64) (*AgentWithdrawalTaxExemption, error)
		Update(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTaxExemption) (sql.Result, error)
		UpdateWithVersion(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTaxExemption) error
		Trans(ctx context.Context, fn func(context context.Context, session sqlx.Session) error) error
		SelectBuilder() squirrel.SelectBuilder
		DeleteSoft(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTaxExemption) error
		FindSum(ctx context.Context, sumBuilder squirrel.SelectBuilder, field string) (float64, error)
		FindCount(ctx context.Context, countBuilder squirrel.SelectBuilder, field string) (int64, error)
		FindAll(ctx context.Context, rowBuilder squirrel.SelectBuilder, orderBy string) ([]*AgentWithdrawalTaxExemption, error)
		FindPageListByPage(ctx context.Context, rowBuilder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AgentWithdrawalTaxExemption, error)
		FindPageListByPageWithTotal(ctx context.Context, rowBuilder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AgentWithdrawalTaxExemption, int64, error)
		FindPageListByIdDESC(ctx context.Context, rowBuilder squirrel.SelectBuilder, preMinId, pageSize int64) ([]*AgentWithdrawalTaxExemption, error)
		FindPageListByIdASC(ctx context.Context, rowBuilder squirrel.SelectBuilder, preMaxId, pageSize int64) ([]*AgentWithdrawalTaxExemption, error)
		Delete(ctx context.Context, session sqlx.Session, id int64) error
	}

	defaultAgentWithdrawalTaxExemptionModel struct {
		sqlc.CachedConn
		table string
	}

	AgentWithdrawalTaxExemption struct {
		Id                       int64        `db:"id"`
		CreateTime               time.Time    `db:"create_time"`
		UpdateTime               time.Time    `db:"update_time"`
		DeleteTime               sql.NullTime `db:"delete_time"` // 删除时间
		DelState                 int64        `db:"del_state"`
		Version                  int64        `db:"version"`                    // 版本号
		YearMonth                int64        `db:"year_month"`                 // 年月标识，格式：202401
		TotalExemptionAmount     float64      `db:"total_exemption_amount"`     // 月度免税总额度
		UsedExemptionAmount      float64      `db:"used_exemption_amount"`      // 已使用免税额度
		RemainingExemptionAmount float64      `db:"remaining_exemption_amount"` // 剩余免税额度
		AgentId                  int64        `db:"agent_id"`                   // 关联到代理用户表的id
	}
)

func newAgentWithdrawalTaxExemptionModel(conn sqlx.SqlConn, c cache.CacheConf) *defaultAgentWithdrawalTaxExemptionModel {
	return &defaultAgentWithdrawalTaxExemptionModel{
		CachedConn: sqlc.NewConn(conn, c),
		table:      "`agent_withdrawal_tax_exemption`",
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) Insert(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTaxExemption) (sql.Result, error) {
	data.DelState = globalkey.DelStateNo
	tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey := fmt.Sprintf("%s%v:%v", cacheTydataAgentWithdrawalTaxExemptionAgentIdYearMonthPrefix, data.AgentId, data.YearMonth)
	tydataAgentWithdrawalTaxExemptionIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxExemptionIdPrefix, data.Id)
	return m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?)", m.table, agentWithdrawalTaxExemptionRowsExpectAutoSet)
		if session != nil {
			return session.ExecCtx(ctx, query, data.DeleteTime, data.DelState, data.Version, data.YearMonth, data.TotalExemptionAmount, data.UsedExemptionAmount, data.RemainingExemptionAmount, data.AgentId)
		}
		return conn.ExecCtx(ctx, query, data.DeleteTime, data.DelState, data.Version, data.YearMonth, data.TotalExemptionAmount, data.UsedExemptionAmount, data.RemainingExemptionAmount, data.AgentId)
	}, tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey, tydataAgentWithdrawalTaxExemptionIdKey)
}

func (m *defaultAgentWithdrawalTaxExemptionModel) FindOne(ctx context.Context, id int64) (*AgentWithdrawalTaxExemption, error) {
	tydataAgentWithdrawalTaxExemptionIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxExemptionIdPrefix, id)
	var resp AgentWithdrawalTaxExemption
	err := m.QueryRowCtx(ctx, &resp, tydataAgentWithdrawalTaxExemptionIdKey, func(ctx context.Context, conn sqlx.SqlConn, v interface{}) error {
		query := fmt.Sprintf("select %s from %s where `id` = ? and del_state = ? limit 1", agentWithdrawalTaxExemptionRows, m.table)
		return conn.QueryRowCtx(ctx, v, query, id, globalkey.DelStateNo)
	})
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) FindOneByAgentIdYearMonth(ctx context.Context, agentId int64, yearMonth int64) (*AgentWithdrawalTaxExemption, error) {
	tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey := fmt.Sprintf("%s%v:%v", cacheTydataAgentWithdrawalTaxExemptionAgentIdYearMonthPrefix, agentId, yearMonth)
	var resp AgentWithdrawalTaxExemption
	err := m.QueryRowIndexCtx(ctx, &resp, tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey, m.formatPrimary, func(ctx context.Context, conn sqlx.SqlConn, v interface{}) (i interface{}, e error) {
		query := fmt.Sprintf("select %s from %s where `agent_id` = ? and `year_month` = ? and del_state = ? limit 1", agentWithdrawalTaxExemptionRows, m.table)
		if err := conn.QueryRowCtx(ctx, &resp, query, agentId, yearMonth, globalkey.DelStateNo); err != nil {
			return nil, err
		}
		return resp.Id, nil
	}, m.queryPrimary)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) Update(ctx context.Context, session sqlx.Session, newData *AgentWithdrawalTaxExemption) (sql.Result, error) {
	data, err := m.FindOne(ctx, newData.Id)
	if err != nil {
		return nil, err
	}
	tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey := fmt.Sprintf("%s%v:%v", cacheTydataAgentWithdrawalTaxExemptionAgentIdYearMonthPrefix, data.AgentId, data.YearMonth)
	tydataAgentWithdrawalTaxExemptionIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxExemptionIdPrefix, data.Id)
	return m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, agentWithdrawalTaxExemptionRowsWithPlaceHolder)
		if session != nil {
			return session.ExecCtx(ctx, query, newData.DeleteTime, newData.DelState, newData.Version, newData.YearMonth, newData.TotalExemptionAmount, newData.UsedExemptionAmount, newData.RemainingExemptionAmount, newData.AgentId, newData.Id)
		}
		return conn.ExecCtx(ctx, query, newData.DeleteTime, newData.DelState, newData.Version, newData.YearMonth, newData.TotalExemptionAmount, newData.UsedExemptionAmount, newData.RemainingExemptionAmount, newData.AgentId, newData.Id)
	}, tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey, tydataAgentWithdrawalTaxExemptionIdKey)
}

func (m *defaultAgentWithdrawalTaxExemptionModel) UpdateWithVersion(ctx context.Context, session sqlx.Session, newData *AgentWithdrawalTaxExemption) error {

	oldVersion := newData.Version
	newData.Version += 1

	var sqlResult sql.Result
	var err error

	data, err := m.FindOne(ctx, newData.Id)
	if err != nil {
		return err
	}
	tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey := fmt.Sprintf("%s%v:%v", cacheTydataAgentWithdrawalTaxExemptionAgentIdYearMonthPrefix, data.AgentId, data.YearMonth)
	tydataAgentWithdrawalTaxExemptionIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxExemptionIdPrefix, data.Id)
	sqlResult, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ? and version = ? ", m.table, agentWithdrawalTaxExemptionRowsWithPlaceHolder)
		if session != nil {
			return session.ExecCtx(ctx, query, newData.DeleteTime, newData.DelState, newData.Version, newData.YearMonth, newData.TotalExemptionAmount, newData.UsedExemptionAmount, newData.RemainingExemptionAmount, newData.AgentId, newData.Id, oldVersion)
		}
		return conn.ExecCtx(ctx, query, newData.DeleteTime, newData.DelState, newData.Version, newData.YearMonth, newData.TotalExemptionAmount, newData.UsedExemptionAmount, newData.RemainingExemptionAmount, newData.AgentId, newData.Id, oldVersion)
	}, tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey, tydataAgentWithdrawalTaxExemptionIdKey)
	if err != nil {
		return err
	}
	updateCount, err := sqlResult.RowsAffected()
	if err != nil {
		return err
	}
	if updateCount == 0 {
		return ErrNoRowsUpdate
	}

	return nil
}

func (m *defaultAgentWithdrawalTaxExemptionModel) DeleteSoft(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTaxExemption) error {
	data.DelState = globalkey.DelStateYes
	data.DeleteTime = sql.NullTime{Time: time.Now(), Valid: true}
	if err := m.UpdateWithVersion(ctx, session, data); err != nil {
		return errors.Wrapf(errors.New("delete soft failed "), "AgentWithdrawalTaxExemptionModel delete err : %+v", err)
	}
	return nil
}

func (m *defaultAgentWithdrawalTaxExemptionModel) FindSum(ctx context.Context, builder squirrel.SelectBuilder, field string) (float64, error) {

	if len(field) == 0 {
		return 0, errors.Wrapf(errors.New("FindSum Least One Field"), "FindSum Least One Field")
	}

	builder = builder.Columns("IFNULL(SUM(" + field + "),0)")

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).ToSql()
	if err != nil {
		return 0, err
	}

	var resp float64
	err = m.QueryRowNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return 0, err
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) FindCount(ctx context.Context, builder squirrel.SelectBuilder, field string) (int64, error) {

	if len(field) == 0 {
		return 0, errors.Wrapf(errors.New("FindCount Least One Field"), "FindCount Least One Field")
	}

	builder = builder.Columns("COUNT(" + field + ")")

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).ToSql()
	if err != nil {
		return 0, err
	}

	var resp int64
	err = m.QueryRowNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return 0, err
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) FindAll(ctx context.Context, builder squirrel.SelectBuilder, orderBy string) ([]*AgentWithdrawalTaxExemption, error) {

	builder = builder.Columns(agentWithdrawalTaxExemptionRows)

	if orderBy == "" {
		builder = builder.OrderBy("id DESC")
	} else {
		builder = builder.OrderBy(orderBy)
	}

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AgentWithdrawalTaxExemption
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) FindPageListByPage(ctx context.Context, builder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AgentWithdrawalTaxExemption, error) {

	builder = builder.Columns(agentWithdrawalTaxExemptionRows)

	if orderBy == "" {
		builder = builder.OrderBy("id DESC")
	} else {
		builder = builder.OrderBy(orderBy)
	}

	if page < 1 {
		page = 1
	}
	offset := (page - 1) * pageSize

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).Offset(uint64(offset)).Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AgentWithdrawalTaxExemption
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) FindPageListByPageWithTotal(ctx context.Context, builder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AgentWithdrawalTaxExemption, int64, error) {

	total, err := m.FindCount(ctx, builder, "id")
	if err != nil {
		return nil, 0, err
	}

	builder = builder.Columns(agentWithdrawalTaxExemptionRows)

	if orderBy == "" {
		builder = builder.OrderBy("id DESC")
	} else {
		builder = builder.OrderBy(orderBy)
	}

	if page < 1 {
		page = 1
	}
	offset := (page - 1) * pageSize

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).Offset(uint64(offset)).Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, total, err
	}

	var resp []*AgentWithdrawalTaxExemption
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, total, nil
	default:
		return nil, total, err
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) FindPageListByIdDESC(ctx context.Context, builder squirrel.SelectBuilder, preMinId, pageSize int64) ([]*AgentWithdrawalTaxExemption, error) {

	builder = builder.Columns(agentWithdrawalTaxExemptionRows)

	if preMinId > 0 {
		builder = builder.Where(" id < ? ", preMinId)
	}

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).OrderBy("id DESC").Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AgentWithdrawalTaxExemption
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) FindPageListByIdASC(ctx context.Context, builder squirrel.SelectBuilder, preMaxId, pageSize int64) ([]*AgentWithdrawalTaxExemption, error) {

	builder = builder.Columns(agentWithdrawalTaxExemptionRows)

	if preMaxId > 0 {
		builder = builder.Where(" id > ? ", preMaxId)
	}

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).OrderBy("id ASC").Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AgentWithdrawalTaxExemption
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxExemptionModel) Trans(ctx context.Context, fn func(ctx context.Context, session sqlx.Session) error) error {

	return m.TransactCtx(ctx, func(ctx context.Context, session sqlx.Session) error {
		return fn(ctx, session)
	})

}

func (m *defaultAgentWithdrawalTaxExemptionModel) SelectBuilder() squirrel.SelectBuilder {
	return squirrel.Select().From(m.table)
}
func (m *defaultAgentWithdrawalTaxExemptionModel) Delete(ctx context.Context, session sqlx.Session, id int64) error {
	data, err := m.FindOne(ctx, id)
	if err != nil {
		return err
	}

	tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey := fmt.Sprintf("%s%v:%v", cacheTydataAgentWithdrawalTaxExemptionAgentIdYearMonthPrefix, data.AgentId, data.YearMonth)
	tydataAgentWithdrawalTaxExemptionIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxExemptionIdPrefix, id)
	_, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
		if session != nil {
			return session.ExecCtx(ctx, query, id)
		}
		return conn.ExecCtx(ctx, query, id)
	}, tydataAgentWithdrawalTaxExemptionAgentIdYearMonthKey, tydataAgentWithdrawalTaxExemptionIdKey)
	return err
}
func (m *defaultAgentWithdrawalTaxExemptionModel) formatPrimary(primary interface{}) string {
	return fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxExemptionIdPrefix, primary)
}
func (m *defaultAgentWithdrawalTaxExemptionModel) queryPrimary(ctx context.Context, conn sqlx.SqlConn, v, primary interface{}) error {
	query := fmt.Sprintf("select %s from %s where `id` = ? and del_state = ? limit 1", agentWithdrawalTaxExemptionRows, m.table)
	return conn.QueryRowCtx(ctx, v, query, primary, globalkey.DelStateNo)
}

func (m *defaultAgentWithdrawalTaxExemptionModel) tableName() string {
	return m.table
}
