// Code generated by goctl. DO NOT EDIT!

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"

	"time"

	"github.com/Masterminds/squirrel"
	"github.com/pkg/errors"
	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
	"tydata-server/common/globalkey"
)

var (
	agentWithdrawalTaxFieldNames          = builder.RawFieldNames(&AgentWithdrawalTax{})
	agentWithdrawalTaxRows                = strings.Join(agentWithdrawalTaxFieldNames, ",")
	agentWithdrawalTaxRowsExpectAutoSet   = strings.Join(stringx.Remove(agentWithdrawalTaxFieldNames, "`id`", "`create_time`", "`update_time`"), ",")
	agentWithdrawalTaxRowsWithPlaceHolder = strings.Join(stringx.Remove(agentWithdrawalTaxFieldNames, "`id`", "`create_time`", "`update_time`"), "=?,") + "=?"

	cacheTydataAgentWithdrawalTaxIdPrefix           = "cache:tydata:agentWithdrawalTax:id:"
	cacheTydataAgentWithdrawalTaxWithdrawalIdPrefix = "cache:tydata:agentWithdrawalTax:withdrawalId:"
)

type (
	agentWithdrawalTaxModel interface {
		Insert(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTax) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*AgentWithdrawalTax, error)
		FindOneByWithdrawalId(ctx context.Context, withdrawalId int64) (*AgentWithdrawalTax, error)
		Update(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTax) (sql.Result, error)
		UpdateWithVersion(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTax) error
		Trans(ctx context.Context, fn func(context context.Context, session sqlx.Session) error) error
		SelectBuilder() squirrel.SelectBuilder
		DeleteSoft(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTax) error
		FindSum(ctx context.Context, sumBuilder squirrel.SelectBuilder, field string) (float64, error)
		FindCount(ctx context.Context, countBuilder squirrel.SelectBuilder, field string) (int64, error)
		FindAll(ctx context.Context, rowBuilder squirrel.SelectBuilder, orderBy string) ([]*AgentWithdrawalTax, error)
		FindPageListByPage(ctx context.Context, rowBuilder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AgentWithdrawalTax, error)
		FindPageListByPageWithTotal(ctx context.Context, rowBuilder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AgentWithdrawalTax, int64, error)
		FindPageListByIdDESC(ctx context.Context, rowBuilder squirrel.SelectBuilder, preMinId, pageSize int64) ([]*AgentWithdrawalTax, error)
		FindPageListByIdASC(ctx context.Context, rowBuilder squirrel.SelectBuilder, preMaxId, pageSize int64) ([]*AgentWithdrawalTax, error)
		Delete(ctx context.Context, session sqlx.Session, id int64) error
	}

	defaultAgentWithdrawalTaxModel struct {
		sqlc.CachedConn
		table string
	}

	AgentWithdrawalTax struct {
		Id                int64          `db:"id"`
		CreateTime        time.Time      `db:"create_time"`
		UpdateTime        time.Time      `db:"update_time"`
		DeleteTime        sql.NullTime   `db:"delete_time"` // 删除时间
		DelState          int64          `db:"del_state"`
		Version           int64          `db:"version"`             // 版本号
		WithdrawalAmount  float64        `db:"withdrawal_amount"`   // 提现金额
		ExemptionAmount   float64        `db:"exemption_amount"`    // 免税金额
		TaxableAmount     float64        `db:"taxable_amount"`      // 应税金额
		TaxRate           float64        `db:"tax_rate"`            // 税率，如：0.2000表示20%
		TaxAmount         float64        `db:"tax_amount"`          // 应缴税费
		ActualAmount      float64        `db:"actual_amount"`       // 实际到账金额
		YearMonth         int64          `db:"year_month"`          // 所属年月，格式：202401
		TaxStatus         int64          `db:"tax_status"`          // 扣税状态：0-待扣税，1-已扣税，2-免税，3-扣税失败
		TaxTime           sql.NullTime   `db:"tax_time"`            // 扣税时间
		Remark            sql.NullString `db:"remark"`              // 备注信息
		AgentId           int64          `db:"agent_id"`            // 关联到代理用户表的id
		WithdrawalId      int64          `db:"withdrawal_id"`       // 关联提现记录表的id
		ExemptionRecordId int64          `db:"exemption_record_id"` // 关联到免税额度记录的id
	}
)

func newAgentWithdrawalTaxModel(conn sqlx.SqlConn, c cache.CacheConf) *defaultAgentWithdrawalTaxModel {
	return &defaultAgentWithdrawalTaxModel{
		CachedConn: sqlc.NewConn(conn, c),
		table:      "`agent_withdrawal_tax`",
	}
}

func (m *defaultAgentWithdrawalTaxModel) Insert(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTax) (sql.Result, error) {
	data.DelState = globalkey.DelStateNo
	tydataAgentWithdrawalTaxIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxIdPrefix, data.Id)
	tydataAgentWithdrawalTaxWithdrawalIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxWithdrawalIdPrefix, data.WithdrawalId)
	return m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, agentWithdrawalTaxRowsExpectAutoSet)
		if session != nil {
			return session.ExecCtx(ctx, query, data.DeleteTime, data.DelState, data.Version, data.WithdrawalAmount, data.ExemptionAmount, data.TaxableAmount, data.TaxRate, data.TaxAmount, data.ActualAmount, data.YearMonth, data.TaxStatus, data.TaxTime, data.Remark, data.AgentId, data.WithdrawalId, data.ExemptionRecordId)
		}
		return conn.ExecCtx(ctx, query, data.DeleteTime, data.DelState, data.Version, data.WithdrawalAmount, data.ExemptionAmount, data.TaxableAmount, data.TaxRate, data.TaxAmount, data.ActualAmount, data.YearMonth, data.TaxStatus, data.TaxTime, data.Remark, data.AgentId, data.WithdrawalId, data.ExemptionRecordId)
	}, tydataAgentWithdrawalTaxIdKey, tydataAgentWithdrawalTaxWithdrawalIdKey)
}

func (m *defaultAgentWithdrawalTaxModel) FindOne(ctx context.Context, id int64) (*AgentWithdrawalTax, error) {
	tydataAgentWithdrawalTaxIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxIdPrefix, id)
	var resp AgentWithdrawalTax
	err := m.QueryRowCtx(ctx, &resp, tydataAgentWithdrawalTaxIdKey, func(ctx context.Context, conn sqlx.SqlConn, v interface{}) error {
		query := fmt.Sprintf("select %s from %s where `id` = ? and del_state = ? limit 1", agentWithdrawalTaxRows, m.table)
		return conn.QueryRowCtx(ctx, v, query, id, globalkey.DelStateNo)
	})
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxModel) FindOneByWithdrawalId(ctx context.Context, withdrawalId int64) (*AgentWithdrawalTax, error) {
	tydataAgentWithdrawalTaxWithdrawalIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxWithdrawalIdPrefix, withdrawalId)
	var resp AgentWithdrawalTax
	err := m.QueryRowIndexCtx(ctx, &resp, tydataAgentWithdrawalTaxWithdrawalIdKey, m.formatPrimary, func(ctx context.Context, conn sqlx.SqlConn, v interface{}) (i interface{}, e error) {
		query := fmt.Sprintf("select %s from %s where `withdrawal_id` = ? and del_state = ? limit 1", agentWithdrawalTaxRows, m.table)
		if err := conn.QueryRowCtx(ctx, &resp, query, withdrawalId, globalkey.DelStateNo); err != nil {
			return nil, err
		}
		return resp.Id, nil
	}, m.queryPrimary)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxModel) Update(ctx context.Context, session sqlx.Session, newData *AgentWithdrawalTax) (sql.Result, error) {
	data, err := m.FindOne(ctx, newData.Id)
	if err != nil {
		return nil, err
	}
	tydataAgentWithdrawalTaxIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxIdPrefix, data.Id)
	tydataAgentWithdrawalTaxWithdrawalIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxWithdrawalIdPrefix, data.WithdrawalId)
	return m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, agentWithdrawalTaxRowsWithPlaceHolder)
		if session != nil {
			return session.ExecCtx(ctx, query, newData.DeleteTime, newData.DelState, newData.Version, newData.WithdrawalAmount, newData.ExemptionAmount, newData.TaxableAmount, newData.TaxRate, newData.TaxAmount, newData.ActualAmount, newData.YearMonth, newData.TaxStatus, newData.TaxTime, newData.Remark, newData.AgentId, newData.WithdrawalId, newData.ExemptionRecordId, newData.Id)
		}
		return conn.ExecCtx(ctx, query, newData.DeleteTime, newData.DelState, newData.Version, newData.WithdrawalAmount, newData.ExemptionAmount, newData.TaxableAmount, newData.TaxRate, newData.TaxAmount, newData.ActualAmount, newData.YearMonth, newData.TaxStatus, newData.TaxTime, newData.Remark, newData.AgentId, newData.WithdrawalId, newData.ExemptionRecordId, newData.Id)
	}, tydataAgentWithdrawalTaxIdKey, tydataAgentWithdrawalTaxWithdrawalIdKey)
}

func (m *defaultAgentWithdrawalTaxModel) UpdateWithVersion(ctx context.Context, session sqlx.Session, newData *AgentWithdrawalTax) error {

	oldVersion := newData.Version
	newData.Version += 1

	var sqlResult sql.Result
	var err error

	data, err := m.FindOne(ctx, newData.Id)
	if err != nil {
		return err
	}
	tydataAgentWithdrawalTaxIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxIdPrefix, data.Id)
	tydataAgentWithdrawalTaxWithdrawalIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxWithdrawalIdPrefix, data.WithdrawalId)
	sqlResult, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ? and version = ? ", m.table, agentWithdrawalTaxRowsWithPlaceHolder)
		if session != nil {
			return session.ExecCtx(ctx, query, newData.DeleteTime, newData.DelState, newData.Version, newData.WithdrawalAmount, newData.ExemptionAmount, newData.TaxableAmount, newData.TaxRate, newData.TaxAmount, newData.ActualAmount, newData.YearMonth, newData.TaxStatus, newData.TaxTime, newData.Remark, newData.AgentId, newData.WithdrawalId, newData.ExemptionRecordId, newData.Id, oldVersion)
		}
		return conn.ExecCtx(ctx, query, newData.DeleteTime, newData.DelState, newData.Version, newData.WithdrawalAmount, newData.ExemptionAmount, newData.TaxableAmount, newData.TaxRate, newData.TaxAmount, newData.ActualAmount, newData.YearMonth, newData.TaxStatus, newData.TaxTime, newData.Remark, newData.AgentId, newData.WithdrawalId, newData.ExemptionRecordId, newData.Id, oldVersion)
	}, tydataAgentWithdrawalTaxIdKey, tydataAgentWithdrawalTaxWithdrawalIdKey)
	if err != nil {
		return err
	}
	updateCount, err := sqlResult.RowsAffected()
	if err != nil {
		return err
	}
	if updateCount == 0 {
		return ErrNoRowsUpdate
	}

	return nil
}

func (m *defaultAgentWithdrawalTaxModel) DeleteSoft(ctx context.Context, session sqlx.Session, data *AgentWithdrawalTax) error {
	data.DelState = globalkey.DelStateYes
	data.DeleteTime = sql.NullTime{Time: time.Now(), Valid: true}
	if err := m.UpdateWithVersion(ctx, session, data); err != nil {
		return errors.Wrapf(errors.New("delete soft failed "), "AgentWithdrawalTaxModel delete err : %+v", err)
	}
	return nil
}

func (m *defaultAgentWithdrawalTaxModel) FindSum(ctx context.Context, builder squirrel.SelectBuilder, field string) (float64, error) {

	if len(field) == 0 {
		return 0, errors.Wrapf(errors.New("FindSum Least One Field"), "FindSum Least One Field")
	}

	builder = builder.Columns("IFNULL(SUM(" + field + "),0)")

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).ToSql()
	if err != nil {
		return 0, err
	}

	var resp float64
	err = m.QueryRowNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return 0, err
	}
}

func (m *defaultAgentWithdrawalTaxModel) FindCount(ctx context.Context, builder squirrel.SelectBuilder, field string) (int64, error) {

	if len(field) == 0 {
		return 0, errors.Wrapf(errors.New("FindCount Least One Field"), "FindCount Least One Field")
	}

	builder = builder.Columns("COUNT(" + field + ")")

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).ToSql()
	if err != nil {
		return 0, err
	}

	var resp int64
	err = m.QueryRowNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return 0, err
	}
}

func (m *defaultAgentWithdrawalTaxModel) FindAll(ctx context.Context, builder squirrel.SelectBuilder, orderBy string) ([]*AgentWithdrawalTax, error) {

	builder = builder.Columns(agentWithdrawalTaxRows)

	if orderBy == "" {
		builder = builder.OrderBy("id DESC")
	} else {
		builder = builder.OrderBy(orderBy)
	}

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AgentWithdrawalTax
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxModel) FindPageListByPage(ctx context.Context, builder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AgentWithdrawalTax, error) {

	builder = builder.Columns(agentWithdrawalTaxRows)

	if orderBy == "" {
		builder = builder.OrderBy("id DESC")
	} else {
		builder = builder.OrderBy(orderBy)
	}

	if page < 1 {
		page = 1
	}
	offset := (page - 1) * pageSize

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).Offset(uint64(offset)).Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AgentWithdrawalTax
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxModel) FindPageListByPageWithTotal(ctx context.Context, builder squirrel.SelectBuilder, page, pageSize int64, orderBy string) ([]*AgentWithdrawalTax, int64, error) {

	total, err := m.FindCount(ctx, builder, "id")
	if err != nil {
		return nil, 0, err
	}

	builder = builder.Columns(agentWithdrawalTaxRows)

	if orderBy == "" {
		builder = builder.OrderBy("id DESC")
	} else {
		builder = builder.OrderBy(orderBy)
	}

	if page < 1 {
		page = 1
	}
	offset := (page - 1) * pageSize

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).Offset(uint64(offset)).Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, total, err
	}

	var resp []*AgentWithdrawalTax
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, total, nil
	default:
		return nil, total, err
	}
}

func (m *defaultAgentWithdrawalTaxModel) FindPageListByIdDESC(ctx context.Context, builder squirrel.SelectBuilder, preMinId, pageSize int64) ([]*AgentWithdrawalTax, error) {

	builder = builder.Columns(agentWithdrawalTaxRows)

	if preMinId > 0 {
		builder = builder.Where(" id < ? ", preMinId)
	}

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).OrderBy("id DESC").Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AgentWithdrawalTax
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxModel) FindPageListByIdASC(ctx context.Context, builder squirrel.SelectBuilder, preMaxId, pageSize int64) ([]*AgentWithdrawalTax, error) {

	builder = builder.Columns(agentWithdrawalTaxRows)

	if preMaxId > 0 {
		builder = builder.Where(" id > ? ", preMaxId)
	}

	query, values, err := builder.Where("del_state = ?", globalkey.DelStateNo).OrderBy("id ASC").Limit(uint64(pageSize)).ToSql()
	if err != nil {
		return nil, err
	}

	var resp []*AgentWithdrawalTax
	err = m.QueryRowsNoCacheCtx(ctx, &resp, query, values...)
	switch err {
	case nil:
		return resp, nil
	default:
		return nil, err
	}
}

func (m *defaultAgentWithdrawalTaxModel) Trans(ctx context.Context, fn func(ctx context.Context, session sqlx.Session) error) error {

	return m.TransactCtx(ctx, func(ctx context.Context, session sqlx.Session) error {
		return fn(ctx, session)
	})

}

func (m *defaultAgentWithdrawalTaxModel) SelectBuilder() squirrel.SelectBuilder {
	return squirrel.Select().From(m.table)
}
func (m *defaultAgentWithdrawalTaxModel) Delete(ctx context.Context, session sqlx.Session, id int64) error {
	data, err := m.FindOne(ctx, id)
	if err != nil {
		return err
	}

	tydataAgentWithdrawalTaxIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxIdPrefix, id)
	tydataAgentWithdrawalTaxWithdrawalIdKey := fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxWithdrawalIdPrefix, data.WithdrawalId)
	_, err = m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
		if session != nil {
			return session.ExecCtx(ctx, query, id)
		}
		return conn.ExecCtx(ctx, query, id)
	}, tydataAgentWithdrawalTaxIdKey, tydataAgentWithdrawalTaxWithdrawalIdKey)
	return err
}
func (m *defaultAgentWithdrawalTaxModel) formatPrimary(primary interface{}) string {
	return fmt.Sprintf("%s%v", cacheTydataAgentWithdrawalTaxIdPrefix, primary)
}
func (m *defaultAgentWithdrawalTaxModel) queryPrimary(ctx context.Context, conn sqlx.SqlConn, v, primary interface{}) error {
	query := fmt.Sprintf("select %s from %s where `id` = ? and del_state = ? limit 1", agentWithdrawalTaxRows, m.table)
	return conn.QueryRowCtx(ctx, v, query, primary, globalkey.DelStateNo)
}

func (m *defaultAgentWithdrawalTaxModel) tableName() string {
	return m.table
}
