package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ OrderRefundModel = (*customOrderRefundModel)(nil)

type (
	// OrderRefundModel is an interface to be customized, add more methods here,
	// and implement the added methods in customOrderRefundModel.
	OrderRefundModel interface {
		orderRefundModel
	}

	customOrderRefundModel struct {
		*defaultOrderRefundModel
	}
)

// NewOrderRefundModel returns a model for the database table.
func NewOrderRefundModel(conn sqlx.SqlConn, c cache.CacheConf) OrderRefundModel {
	return &customOrderRefundModel{
		defaultOrderRefundModel: newOrderRefundModel(conn, c),
	}
}
