package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ QueryCleanupConfigModel = (*customQueryCleanupConfigModel)(nil)

type (
	// QueryCleanupConfigModel is an interface to be customized, add more methods here,
	// and implement the added methods in customQueryCleanupConfigModel.
	QueryCleanupConfigModel interface {
		queryCleanupConfigModel
	}

	customQueryCleanupConfigModel struct {
		*defaultQueryCleanupConfigModel
	}
)

// NewQueryCleanupConfigModel returns a model for the database table.
func NewQueryCleanupConfigModel(conn sqlx.SqlConn, c cache.CacheConf) QueryCleanupConfigModel {
	return &customQueryCleanupConfigModel{
		defaultQueryCleanupConfigModel: newQueryCleanupConfigModel(conn, c),
	}
}
