package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ QueryCleanupLogModel = (*customQueryCleanupLogModel)(nil)

type (
	// QueryCleanupLogModel is an interface to be customized, add more methods here,
	// and implement the added methods in customQueryCleanupLogModel.
	QueryCleanupLogModel interface {
		queryCleanupLogModel
	}

	customQueryCleanupLogModel struct {
		*defaultQueryCleanupLogModel
	}
)

// NewQueryCleanupLogModel returns a model for the database table.
func NewQueryCleanupLogModel(conn sqlx.SqlConn, c cache.CacheConf) QueryCleanupLogModel {
	return &customQueryCleanupLogModel{
		defaultQueryCleanupLogModel: newQueryCleanupLogModel(conn, c),
	}
}
