package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ UserTempModel = (*customUserTempModel)(nil)

type (
	// UserTempModel is an interface to be customized, add more methods here,
	// and implement the added methods in customUserTempModel.
	UserTempModel interface {
		userTempModel
	}

	customUserTempModel struct {
		*defaultUserTempModel
	}
)

// NewUserTempModel returns a model for the database table.
func NewUserTempModel(conn sqlx.SqlConn, c cache.CacheConf) UserTempModel {
	return &customUserTempModel{
		defaultUserTempModel: newUserTempModel(conn, c),
	}
}
